/*
Barre d'Outils OGSPY, extension firefox d'aide aux mise à jour de serveurs OGSPY

OGSPY Toolbar, a firefox plugin for helping players in updating OGSPY servers game datas

Copyright (C) 2006-2007 Naqdazar (ajdr@free.fr)

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier
au titre des clauses de la Licence Publique Générale GNU, telle que publiée par la
Free Software Foundation ; soit la version 2 de la Licence.
Ce programme est distribué dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ;
 sans mÛme une garantie implicite de COMMERCIABILITE ou DE CONFORMITE A UNE UTILISATION PARTICULIERE. 
 
 Voir la Licence Publique Générale GNU pour plus de détails. 
 
 Vous devriez avoir reþu un exemplaire de la Licence Publique Générale GNU avec ce programme ;
  si ce n'est pas le cas, écrivez à la Free Software Foundation Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

This program is free software; you can redistribute it and/or modify it under the
terms of the GNU General Public licence as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 See the GNU General Public License for more details.

You should have received a copy of the GNU General Public licence along with this program;
 if not, write to the Free Software Foundation, Inc., 
 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

/**
*
* example [English]
*
* @package ogsplugin
* Barre d'Outils pour Ogame/OGSPY - FireSpy
* @version $Id: v2.0 $
* @copyright (c) 2006-2007 Naqdazar(ajdr@free.fr)
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/


// exemple pour que ça marche &pluginversion=1.0.95.3"; .3 facultatif

//=================================constantes générales===============================
const ogsversion_plugin='3.0.0';
const ogsidentstrings="&webagent=ogsplugin&webbrowser=firefox&pluginversion="+ogsversion_plugin;
const supportforum_urlstring="http://forum.e-univers.org/";
const disable_extra_page_detection=true; // commun mais concernait Ogame d'abord, doit signaler le refus de détection de page extra dans les tests
const ogs_StatusLabelsHistoryLenght = 100;

//=======================================================================================
var prefs = OGPlugin_getPrefs();
var OGPlugin_activated = 0;
var OGPlugin_result = 2;
var OGPlugin_TrigDoc=null;
var LastServerPostError=false;
var SendButtonActionCmd="";
var CurrentDocUrl="";

var ogs_askforshowallfrxproperties = false; // demande d'affichage de about:config pour effacement manuel
/* ogs_askformanclearallproperties */

var ogs_doprintfirespyprefs = false;

// Variable globales sur les jeux en ligne pris en charge
const ogs_ogametype = 'ogame';
const ogs_euniverstype = 'eunivers';
//const ogs_exiletype = 'exile';
//const ogs_traviantype = 'travian';
var ogs_gametype = ""; // 'ogame'(ogs_ogametype) ou 'eunivers'(ogs_euniverstype) ou 'exile', 'travian'
var IsOGameDomain = false;
var IsEUniversDomain = false;

var ogs_serverrankid=0; // 1, 2, 3, 4, 5, 6, 7
var ogs_messagetype=""; // espio,combat,user,ally,general

var ogs_firsttime_onogamepageload = true; // toujours vrai au démarrage
var ogs_toolbarhasstartedyet = false;
var ogs_onstart_collapsed = false; // état caché ou pas de la barre au démarrage

var ogs_StatusLabelsHistory = new Array(); // tableau historique pour les messages de la barre d'état du plugin
var ogs_laststatuslabel = ""; // chaine tampon pour le dernier message affiché sur la barre
var ogs_gameprefixmsg=""; // Ogame ou E-Univers: recevra une des constante de type jeu définie(ex ogamemsglabel)

//Analyse chargement des adresses
var ogs_checkurlondomload = new Array(false, "");
var ogs_checkurlonpageloaded = new Array(true, "");

// Variables globales Ogame déplacées dans ogs_ogamehooks.js

const ogspymsglabel = "OGSpy - "; // -> toolbarmsgprefix
const ogamemsglabel = "Ogame - "; // -> toolbarmsgprefix
const eunivmsglabel = "E-Univers - "; // -> toolbarmsgprefix
//const exilemsglabel = "Exile - "; // -> toolbarmsgprefix
//const travianmsglabel = "Travian - "; // -> toolbarmsgprefix

/**
 * \fn Point d'entrée du fichier principal de l'extension
 */
function init() { OGPlugin_ext.init(); }

/**
 * ne pas changer le paramètre "load"!
 */
window.addEventListener("load", init, false); // DOMContentLoaded provoque changements d'état intermittent du bouton activer
gBrowser = window.getBrowser();

/**
 * \class OGPlugin_ext
 *   \brief Définition de la "classe" interne de l'extension et de ses événements
 */
var OGPlugin_ext = {

    /** \fn init()
     * Fonction d'initialisation, point d'entrée de la classe OGPlugin_ext
     */
    init: function() {                 

        // initialisation de la variable des propriétés du plugin
        //prefs = OGPlugin_getPrefs();

        // Initialisation des noms associés(who, type) pour les stats Ogame
        OGPlugin_InitStatsTabNames();
               
        OGPlugin_SetStatusViewLabel("notify",OGPlugin_GetLocString("toolbar.firstinit"));

        // Récupération d'une "référence XUL du navigateur"
        var appcontent = document.getElementById("appcontent");   // browser
        if(appcontent!=null) {
      	    //appcontent.addEventListener("load", this.onPageLoad, true);
            // déclaration de l'événement à déclencher
            appcontent.addEventListener(/* 'load' */ 'DOMContentLoaded' , this.onPageLoad, true);
            appcontent.addEventListener('load' , this.onPageLoaded, true); // page complète chargée -> affichage barre ou pas?

        } else return; // navigateur incompatible ou exception inconnue
        
        // Initialisation pour interception événement onglet
        var container = gBrowser.tabContainer;
        container.addEventListener("TabSelect", this.onTabSelect, false);
        

        // activation de l'extension au démarrage?
        if (OGPlugin_getBoolPref('OGPlugin.settings.autostarten', false, '') == true) OGPlugin_Activate();
            
        // détection d'une mise à jour au démarrage
        if (OGPlugin_getBoolPref('OGPlugin.settings.checkupdtonstart', false, 'OGPlugin-checkupdtonstart')==true
            && ogs_toolbarhasstartedyet==false)
            OGPlugin_UpdateToolbar(false, false, true);
            


        // sauvegarde de l'état affiché ou pas de la barre au démarrage
        ogs_onstart_collapsed = document.getElementById('OGPlugin-Toolbar').collapsed;
        
        if (ogs_frx15compat_debugmode==true) alert("fin Init frx 15"); // débogage compat firefox 1.5
        
        // indique que la barre a déjà été initialisée
        ogs_toolbarhasstartedyet = true;

    },
    
    /**
     * @function onTabSelect(aEvent)
     * Méthode évenementielle de la classe OGPlugin_ext pour l'évenement de sélection d'un onglet(clic souris).
     */
    onTabSelect: function(aEvent) { // méthode évenementielle pour déterminer si afficher barre d'outils ou pas

        // la barre d'outils est-elle activée?
        if (OGPlugin_activated == 0) return;

        if (ogs_frx15compat_debugmode==true) alert("onTabSelect frx 15");
        // code indépendant du type de jeu internet pris en charge
        // récupération de la version du navigateur
        browserversion = OGPlugin_GetFirefoxVersion();
        if (browserversion[0]!='1') { // non firefox 1.5 seulement
            // afficher toolbar si targetdoc sauvegardé est page Ogame
            if (OGPlugin_getBoolPref('OGPlugin.settings.autohide', false, '')) {
                var tabcool = OGPlugin_TabGetLocaldata('ogspytoolbar_docollapse', 'false');
                document.getElementById('OGPlugin-Toolbar').collapsed =  !(tabcool=='false' || tabcool==false);
            }
        }
            
        if (ogs_hideonnonogamepage==true) alert('selected tab doc.location.href docollapse: '+tabcool);

    },
    
    onPageLoaded: function(aEvent) {

                  // la barre d'outils est-elle activée?
                  if (OGPlugin_activated == 0) return;
                  ogs_checkurlonpageloaded[0] = true; // utilité à revoir;
                  ogs_checkurlonpageloaded[1] = aEvent.originalTarget.location.href;

                  /* var ogs_checkurlondomload = new Array(false, "");
                  var ogs_checkurlonpageloaded = new Array(true, ""); */
                  
                  if(ogs_checkurlondomload[0] == ogs_checkurlonpageloaded[0] && /* booléen utiles */
                     ogs_checkurlondomload[1] == ogs_checkurlonpageloaded[1] ) {
                     
                     ogs_checkurlondomload[0] = false;
                     ogs_checkurlondomload[1] = "";

                     ogs_checkurlonpageloaded[0] = false; // derniere réponse à l'événement
                     ogs_checkurlonpageloaded[1] = "";
                     
                     
                     if (ogs_hideonnonogamepage) alert('onPageLoaded: page chargee\n'+aEvent.originalTarget.location.href);
                  }
    },

    /**
     * Fonction appelée à chaque chargement d'une adresse
     **/
    onPageLoad: function(aEvent) {

        // Capture du document "appelant"
        var doc = aEvent.originalTarget; // doc est le document qui a généré l'événement "onload"

        // le document possède-t-il une référence valide?
        if (doc.location == null ) return 0; // pas d'url trouvée!

        // récupération de l'url du document "acteur" (onload)
        CurrentDocUrl = doc.location.href; // contient l'adresse jusqu'à .php pas les paramÞtres...
        if (ogs_hideonnonogamepage) alert(CurrentDocUrl);
        

        
        // détermination des domaines de jeux en présence
        IsOGameDomain = OGPlugin_IsOGameDomain(CurrentDocUrl);
        IsEUniversDomain = OGPlugin_IsEUniversDomain(CurrentDocUrl);
       // IsExileDomain = OGPlugin_IsExileDomain(CurrentDocUrl);
       // IsTravianDomain = OGPlugin_IsTravianDomain(CurrentDocUrl);
        IsAcceptedDomain = (IsOGameDomain || IsEUniversDomain /*|| IsExileDomain || IsTravianDomain*/);
        
        // afficher la barre d'outils ou pas
        if (!ogs_checkurlondomload[0] && OGPlugin_getBoolPref('OGPlugin.settings.autohide', false, ''))
            OGPlugin_HideToolbar(IsAcceptedDomain, ogs_onstart_collapsed);
            
        // Initialisation des variables OnContentLoad et OnPageLoaded
        ogs_checkurlondomload[0] = true;
        ogs_checkurlondomload[1] = CurrentDocUrl;
        ogs_checkurlonpageloaded[0] = false;
        ogs_checkurlonpageloaded[1] = "";
        
        // cas IsOGameDomain==false -> OGPlugin_TrigDoc = null; // non! cas ouverture portail serveur ogspy puis tentative envoi rapports
        if (!IsAcceptedDomain) return false; // quitter, aucune page ogame n'a été détectée
        // général IsAcceptedDomain = OGPlugin_IsOGameDomain() || OGPlugin_IsEuniversDomain

        //============================CODE COMMUN OBLIGATOIRE ======================================

        // Execution de code lors du premier événement générateur
        if (ogs_firsttime_onogamepageload && ogs_toolbarhasstartedyet) {
            ogs_firsttime_onogamepageload = false;
            OGPlugin_OnFirstPageLoad();
            
        }
        
        /** la barre d'outils est-elle activée?
         *  vérifier informtions nécéssitant d'être traitées
         **/
        if (OGPlugin_activated == 0) return;
        




        // on retire le lien de nouvelle page Ogame si coché dans les options
        if (OGPlugin_getBoolPref('OGPlugin.settings.enableogamespeedlink', false, '')==true)
            OGPlugin_UnsetNewOgamePageSpeedlink();
        //=============================================================================================
            

        
        if (ogs_frx15compat_debugmode==true) alert("debut OnPageload frx 15 ");
        //=============================================================================================================
        
        // pour déterminer le numéro d'univers ogame (iframe racine gauche->numéro univers)
        // déterminer le frame racine ==> function OGPlugin_GetCurrentOgameServerNum()
        
        // capturer l'étiquette Univers XX (Ogame)
        current_nounivers = OGPlugin_GetCurrentOgameServerNum(doc); // à revoir

        // si numéro univers a changé, vider tampon stats pour éviter interférences
        if (ogs_lastnounivers!=0 && ogs_lastnounivers!=current_nounivers) { // code à revoir, pas fini
            OGPlugin_FlushBuffers();
        } else ogs_lastnounivers = current_nounivers; // sauvegarde de la valeur
        
        // stocker dans espace de l"onglet: facultatif, stocker dans espace plugin commun à tous les onglets
        // si no univers a changé
        
        //=============================================================================================================


        // pour toutes les actions
        
        if (ogs_frx15compat_debugmode==true) alert("OnPageload frx 15 avant OGPlugin_IsOGameDomain");
                                   

        if (ogs_frx15compat_debugmode==true) alert("OnPageload frx 15 avant IsOGameDomain==");



        // désactivation du bouton envoyer
        document.getElementById("OGPlugin-reports").disabled = true;

        // notification de veille de la barre d'outils
        OGPlugin_SetStatusViewLabel("notify",OGPlugin_GetLocString( "toolbar.status.nothing" ));
        
        // initialisation de variables dépendante du jeu en présence
        if (IsOGameDomain) {
            ogs_gameprefixmsg = ogamemsglabel; // si Ogame
            ogs_gametype = ogs_ogametype;
        } else if(IsEUniversDomain) {
            ogs_gameprefixmsg = eunivmsglabel; // si EUnivers
            ogs_gametype = ogs_euniverstype;
        }/* else if(IsExileDomain) {
            ogs_gameprefixmsg = exilemsglabel; // si Exile
            ogs_gametype = ogs_exiletype;
        } else if(IsTravianDomain) {
            ogs_gameprefixmsg = travianmsglabel; // si Travian
            ogs_gametype = ogs_traviantype;
        }*/

        OGPlugin_TrigDoc = doc;// sauvegarde seulement si page Ogame ou e-univers!!!
            
        // extraction nom serveur Ogame depuis URl
        OGPlugin_ExtractOgameServerFromUrl(CurrentDocUrl);

        //=========================================================================================
        // Initialisation des variables locales
        var text="";
        var statusviewline="";
        // init vars Ogame
        ogs_ismodecommandant=false;
        ogs_messagetype="";
        //=========================================================================================


        //=========================================================================================
        // recherche de l'id serveur associé à l'univers en cours (Ogame ou EUnivers indiffémment)
        var lresurlassoc = OGPlugin_GetAssocOGSpyUrl(CurrentDocUrl);
        if (lresurlassoc!=false) {
            ogs_targetogspyurl = lresurlassoc[0];
            ogs_targetserverid = lresurlassoc[1]; // sert notament pour la surbrillance et la lecture des pseudo pour rapport de combat
            ogs_targetservername = lresurlassoc[2]; // sert notament pour la surbrillance et la lecture des pseudo pour rapport de combat
        }
        //==================================================================================================================
        // Mise à jour des infos de surbrillance depuis premier serveur ogspy correspondant: une seule fois au démarrage
        if (lresurlassoc!=false) OGPlugin_OgameChkHighlightingOnStart(lresurlassoc); // debug: else alert("Infos OGPlugin_GetAssocOGSpyUrl: "+ogs_targetserverid+ " - "+ogs_targetogspyurl+"\n"+CurrentDocUrl);
        //==================================================================================================================
        
        if (IsOGameDomain && OGPlugin_getBoolPref('OGPlugin.settings.handleogame', true, '')) {
            // Détection groupée des pages Ogame prises en charge
            OGPlugin_OgameChkAllHandledPages(doc);
        } else if(IsEUniversDomain && OGPlugin_getBoolPref('OGPlugin.settings.handleeunivers', true, '')) {
            /* fonctions de détections ici en attendant externalisation dans fichiers */
            OGPlugin_EUniversChkAllHandledPages(doc);
        } /*else if(IsExileDomain && OGPlugin_getBoolPref('OGPlugin.settings.handleexile', true, '') ) {
            // fonctions de détections ici en attendant externalisation dans fichiers 
            OGPlugin_ExileChkAllHandledPages(doc);
        } else if(IsTravianDomain && OGPlugin_getBoolPref('OGPlugin.settings.handletravian', true, '')) {
            // fonctions de détections ici en attendant externalisation dans fichiers 
            OGPlugin_TravianChkAllHandledPages(doc);
        }*/
        

   }
}

function OGPlugin_OnFirstPageLoad() {

        // Affichage du panneau de license et du message de bienvenue - commun
        if (prefs.prefHasUserValue("OGPlugin.settings.handlegalaxyviews")==false) {
            OGPlugin_ShowLicence();
            alert(OGPlugin_GetLocString("welcome_firstmsg"));

            // Affichage du Panneau Options
            if (OGPlugin_getBoolPref('OGPlugin.settings.showfalseconfigpopups', true, ''))
            OGPlugin_ShowOptionsPanel();
        }

}

/**
 * Méthode événement associé au bouton Envoyer
 **/
function OGPlugin_GetPageReport() { // n'admet pas de paramÞtres, méthode événementielle
    /* préparation pour Eunivers: devra appeler une fonction OGPlugin_GetEUNiversPageReport
       ou OGPlugin_GetOgamePageReport pour Ogame
       à déterminer suivant le domaine de jeu déterminé ou l'url/serveur
       isogamedomaine -> gametype='ogame'
       if (gametype=='ogame') OGPlugin_GetOgamePageReport();
    */
    if (ogs_gametype==ogs_ogametype) OGPlugin_GetOgamePageReport();
    else if (ogs_gametype==ogs_euniverstype) OGPlugin_GetEUniversPageReport();
    //else if (ogs_gametype==ogs_exiletype) OGPlugin_GetExilePageReport();
    //else if (ogs_gametype==ogs_traviantype) OGPlugin_GetTravianPageReport();
   
}

/**
 * fonction d'envoi direct de données sur le portail OGSPY/UniSpy
 **/
/* function OGPlugin_sendTextLikeUser(typ, text, source_url) {

} */

/**
 * Fonction de préparation d'envoi des données vers un serveur/compte de jeu
 * @param typ chaîne: indique l'opération et la nature des données à envoyer/traiter
 * @param text string: données à envoyer
 * @param source_url chaîne: adresse du serveur de jeu en cours sur lequel la capture de page a eu lieu
 **/
function OGPlugin_sendText(typ,text,source_url, parsendtype) {
  
      if (parsendtype == null || parsendtype == '') parsendtype = 'ogspymodsend';
  
      // vérification que l'url reçue est une url ogame 
       if (source_url=="" || source_url==null) {
          OGPlugin_SetStatusViewLabel("failure", OGPlugin_GetLocString("error.pageurl.unknown"));
          return 0;
       }   
       
       if (ogs_sendmodedebug) alert(parsendtype);
       // affichage contenu avant envoi
       if (ogs_presending_debug_mode==true) alert(text);

       // ========================= Début préparation données Ogame pour transmission =========================================
       
       // remplacé par RegExpOgameUrl: ogameserver_pattern -> RegExpOgameUrl
       if (ogs_gametype == ogs_ogametype) var gameserver_pattern = new RegExp("http\:\/\/([a-z,A-Z,0-9,\.]+)\/game\/","");
       else if (ogs_gametype == ogs_euniverstype) var gameserver_pattern = /http\:\/\/([a-z,A-Z,0-9]+\.(e\-univers|projet42)\.org)/;  //new RegExp("http\:\/\/([a-z,A-Z,0-9]+)\.e\-univers\.org\/","")
       
	  
       //var targeturlhead = targeturlhead.match(head_pattern);
       //var real_game_server = ogameserver_pattern.exec(source_url)[1]; // eg: doit retourner chaine du genre ogame190.de
       
       
       var res_gameurl_server = source_url.match(gameserver_pattern); // eg: doit retourner chaine du genre ogame190.de
       
       var real_game_server ="";
       if (res_gameurl_server!=null) real_game_server = res_gameurl_server[1];
       else {
			// ufLog("HERE"+source_url);
			// ufDump(res_gameurl_server);
            OGPlugin_SetStatusViewLabel("failure",OGPlugin_GetLocString("error.serverurl.readerror")+":\n"+source_url);
            return 0;             
       }
       //=======================================================================   
        var txt = "";
        /**
         * commandes ogspy : none, basic, general_player, fleet_player, research_player,
         * general_ally, fleet_ally, research_ally
         **/
        var usercmd = ""; 

        /* voir pour fonction retournant un tableau! (ogame, eunivers, ...)
           txt = return tab[0];
           OGPlugin_responsetext=return tab[1];
           pour Ogame SndTxtPrepareData(partype, parstatwho, parseltype
        */
        if (typ == "stats") {
            txt = txt + "&who="+OGPlugin_selectedWho+"&what="+OGPlugin_selectedTyp;
            if (OGPlugin_selectedWho == 0) {
              OGPlugin_responsetext = OGPlugin_GetLocString("statsupdated.playerprefix")+":";
              response_Whoname = OGPlugin_GetLocString("statsupdated.playerprefix");
            }
            if (OGPlugin_selectedWho == 1) {
              OGPlugin_responsetext = OGPlugin_GetLocString("statsupdated.allyprefix")+":";
              response_Whoname = OGPlugin_GetLocString("statsupdated.allyprefix");
            }
            if (OGPlugin_selectedTyp == 0) OGPlugin_responsetext = OGPlugin_responsetext + OGPlugin_GetLocString("statsupdated.scoreinfix")+OGPlugin_selectedRanks+OGPlugin_GetLocString("statsupdated.suffix");
            if (OGPlugin_selectedTyp == 1) OGPlugin_responsetext = OGPlugin_responsetext + OGPlugin_GetLocString("statsupdated.fleetinfix")+OGPlugin_selectedRanks+OGPlugin_GetLocString("statsupdated.suffix");
            if (OGPlugin_selectedTyp == 2) OGPlugin_responsetext = OGPlugin_responsetext + OGPlugin_GetLocString("statsupdated.researchinfix")+OGPlugin_selectedRanks+OGPlugin_GetLocString("statsupdated.suffix");
        }
        if (typ == "galaxy" || typ == "galaxyraw") {
            txt = txt + "&galaxy="+OGPlugin_selectedGalaxy+"&system="+OGPlugin_selectedSystem;
            OGPlugin_responsetext = OGPlugin_GetLocString("galaxyupdated.prefix")+OGPlugin_selectedGalaxy+":"+OGPlugin_selectedSystem+OGPlugin_GetLocString("galaxyupdated.suffix");
        }
        if (typ == "reports") {
            if (OGPlugin_getBoolPref("OGPlugin.settings.autoreporten", false, '') == true)
                OGPlugin_responsetext = OGPlugin_GetLocString("reportsupdated")+" (auto)"
            else OGPlugin_responsetext = OGPlugin_GetLocString("reportsupdated");
            //alert(text);
        }
        if (typ == "allyhistory") {
            txt = txt + "&alliance="+AllyTAGFound /* var commun dans ogs_ogamehooks; */
            OGPlugin_responsetext = OGPlugin_GetLocString("allyhistoryupdated");
        }
        if (typ == "buildings") {
            txt = txt + "&planetsource="+encodeURIComponent(PlanetNameWithCoords);
            OGPlugin_responsetext = OGPlugin_GetLocString("buildingstransfered")+OGPlugin_GetLocString("planettranfertinfix")+PlanetNameWithCoords;
        }
        if (typ == "resources") {
            txt = txt + "&planetsource="+encodeURIComponent(PlanetNameWithCoords);
            OGPlugin_responsetext = OGPlugin_GetLocString("resourcestransfered")+OGPlugin_GetLocString("planettranfertinfix")+PlanetNameWithCoords;
        }
        if (typ == "technos") {
            txt = txt + "&planetsource="+encodeURIComponent(PlanetNameWithCoords);
            OGPlugin_responsetext = OGPlugin_GetLocString("technostransfered")+OGPlugin_GetLocString("planettranfertinfix")+PlanetNameWithCoords;
        }
        if (typ == "shipyard") {
            txt = txt + "&planetsource="+encodeURIComponent(PlanetNameWithCoords);
            OGPlugin_responsetext = OGPlugin_GetLocString("shipyardtransfered")+OGPlugin_GetLocString("planettranfertinfix")+PlanetNameWithCoords;
        }
        if (typ == "defence") {
            txt = txt + "&planetsource="+encodeURIComponent(PlanetNameWithCoords);
            OGPlugin_responsetext = OGPlugin_GetLocString("defencetransfered")+OGPlugin_GetLocString("planettranfertinfix")+PlanetNameWithCoords;
        }
        if (typ == "flotten") {
            txt = txt + "&planetsource="+encodeURIComponent(PlanetNameWithCoords);
            OGPlugin_responsetext = OGPlugin_GetLocString("defencetransfered")+OGPlugin_GetLocString("planettranfertinfix")+PlanetNameWithCoords;
        }
        if (typ == "combreports") {
            txt = txt + "&planetsource="+encodeURIComponent(PlanetNameWithCoords);
            OGPlugin_responsetext = OGPlugin_GetLocString("combatreptransfered")+OGPlugin_GetLocString("planettranfertinfix")+PlanetNameWithCoords;
        }
        if (typ == "planetdetails") {
            txt = txt + "&planetsource="+encodeURIComponent(PlanetNameWithCoords);
            OGPlugin_responsetext = "detaisl envoyes"+OGPlugin_GetLocString("planettranfertinfix")+PlanetNameWithCoords;
        }

        
        // Sécurisation des infos sessionid=
        text = OGPlugin_CleanSessionIdData(text);
        
        // alert("sur le point d'envoyer "+txt+ogsidentstrings +" -|"+url+"|");
        txt = txt + ogsidentstrings+"&realogameserver="+encodeURIComponent(real_game_server) + "&content=" + encodeURIComponent(text)+"&gametype="+ogs_gametype; // needed to send data with special chars like \s or \n
        // ========================= fin préparation données Ogame pour transmission =========================================


        LastServerPostError = false;

    //try {
        var url = "";          
                      
       var lhandlehttprequest = true;
       var lasynchttprequest = true;
                   

        // code suivant obsolÞte
        /* if (prefs.prefHasUserValue("OGPlugin.settings.serverstatrank"))
            serverstatrank = OGPlugin_getIntPref("OGPlugin.settings.serverstatrank", 0 ,'');
        else serverstatrank=0; */
        
        // parcours des lignes de saisie des comptes ogspy
        cpt=1
        var serverfound=false;
        var atleastoneserverfound=false;
        var tmpurltotest="";
        while (cpt<8) {
            tmpurltotest = OGPlugin_getCharPref("OGPlugin.settings.ogameurl"+cpt , '' ,'');
            cmdpasscrypted = "";
            if (OGPlugin_getBoolPref("OGPlugin.settings.iscryptedpass"+cpt , true ,'')==true) {
                cmdpasscrypted ="&crypted=ogspy";
            };
            // if (ogs_debug_mode==true) alert("etat crypate pour server "+cpt+" : "+cmdpasscrypted );
            ogameurltotest = OGPlugin_TrimString(tmpurltotest);
            if (ogameurltotest!="" && source_url.search(ogameurltotest) > -1 ) {
                ogs_serverrankid=cpt;
                try {
                    // ajout nom joueur
                    if (typ == "combreports")
                      txt = txt+"&sendernick="+OGPlugin_getCharPref('OGPlugin.settings.playernick'+cpt, '<aucun_nick>', '');
                    if (ogs_sendtextdebug_mode==true) alert("nick attaquant: "+OGPlugin_getCharPref('OGPlugin.settings.playernick'+cpt, '<aucun_nick>', ''))
                    
                    /* préparation pour l'insertion du nom d'utilisateur et du mot de passe */
                    txthead = "user="+OGPlugin_getCharPref("OGPlugin.settings.username"+cpt , '' ,'')+"&password="+OGPlugin_getCharPref("OGPlugin.settings.password"+cpt , '' ,'')+cmdpasscrypted+"&typ="+typ+"&ogameurl="+OGPlugin_getCharPref("OGPlugin.settings.ogameurl"+cpt , '' ,'')+txt+"&serverrank="+ogs_serverrankid;
                    // url = OGPlugin_getCharPref("OGPlugin.settings.url"+cpt , '' ,'');
                    url = OGPlugin_GetOGSPYUrl(cpt); // récupération et/ou décodage de l'url ogspy / unispy
                } catch(e) {
                    OGPlugin_ShowAlertPopup("configerror",OGPlugin_GetLocString("error_missingwrongogspyparams"));
                    return 0;
                }
                
                if (url!="") atleastoneserverfound=true;
  

                // détermination du type d'envoi requis
                if (parsendtype == 'ogspygatesend' || OGPlugin_getBoolPref('OGPlugin.settings.gatesendmod', false, '')) { // cas envoi direct sur portail serveur données(comme si l'utilisateur fsaiit une maj manuelle)
                
                   var txtcmd="action=get_data";

                   var url_gatepattern = /ogsplugin\d{0,2}\.php|xtense\.php/gi;

                   // on récupÞre l'adresse qui doit se terminer par index.php
                   var gateurl = url.replace(url_gatepattern, "index.php");

                    if (typ == "stats") {
                      txtcmd += "&datatype="+usercmd_labeltab[OGPlugin_selectedWho][OGPlugin_selectedTyp];
                    } else if (typ == "galaxy" || typ == "reports") {
                      txtcmd += "&datatype=basic";
                    }
                    
                    var parcontent = txtcmd+"&data="+text;
                    


                    if (ogs_sendmodedebug) alert("parsendtype: "+parsendtype+"\ngateurl:"+gateurl+"\nuser_cmd:"+txtcmd);
                    
                    // envoie asynchrone sans attente de réponse
                   OGPlugin_SendhttpRequest(parcontent, gateurl, true, false, cpt, false);
                } else { // envoi classique vers module OGS Plugin
                    // vérification si serveur stat: envoie seulement statistiques
                    if (OGPlugin_getBoolPref('OGPlugin.settings.isstatserver'+cpt, false, '')==true)
                    {
                        if (typ == "stats")
                            OGPlugin_SendhttpRequest(txthead, url, lasynchttprequest, lhandlehttprequest, cpt, true);
                        else OGPlugin_SetStatusViewLabel("notify", OGPlugin_GetLocString("error.nonstatsdatanothandled")+"("+cpt+")!");
                    } else OGPlugin_SendhttpRequest(txthead, url, lasynchttprequest, lhandlehttprequest, cpt, true);
                }
                
                if (OGPlugin_getBoolPref("OGPlugin.settings.multisserversend", false, '')==false) {
                   break;
                 } 
                if (!serverfound) OGPlugin_SetStatusViewLabel("notify",OGPlugin_GetLocString("waitingformultiplerequests"));  
                serverfound=true;
            }
            
            cpt++;
        }
       //alert("requÞte envoyée");
       if (atleastoneserverfound==false) {
            OGPlugin_ShowAlertPopup("configerror",OGPlugin_GetLocString("error.noogspyaccountfound"));
            return 0;
       } 

    return 0;
}

/**
 * Fonction d'envoi de données vers un serveur php à proprement parler.
 * Utilise la classe objet AJAX XMLHttpRequest
 * @param parContent chaîne
 * @param parUrl chaîne
 * @param parASync booléen
 * @param parHandleReadyState booléen
 * @param servernum entier
 **/
function OGPlugin_SendhttpRequest (parContent, parUrl, parASync , parHandleReadyState, servernum, parogsclientmod) {
        var HttpHandleResult=0;
        
        if(parogsclientmod==null || parogsclientmod == '') parogsclientmod = true; // définition par défaut
        
        if (ogs_sendtextdebug_mode==true) alert(parContent);
        if (parUrl=="") {
            OGPlugin_ShowAlertPopup("configerror",OGPlugin_GetLocString("error_wrongogspyaccountparams.prefix")+servernum+OGPlugin_GetLocString("error_wrongogspyaccountparams.suffix"));
            return 0;
        }
        function OGPlugin_PrepareToHandle(e) {
                var httpreadystate = httpRequest.readyState;
                //alert("state: "+httpreadystate);
  
                if (httpreadystate==4 || paronload==1) { // attention sous firefox
                    var temphttpstatus=httpRequest.status;
                    var temphttpresponse = OGPlugin_RemoveJavaScriptTags(httpRequest.responseText);
                    var temphttpresponsecode = parseInt(temphttpresponse.substr(0,3));

                    var notifymode=0;
                    if(prefs.prefHasUserValue("OGPlugin.settings.notifymode"+servernum))
                       notifymode = OGPlugin_getIntPref("OGPlugin.settings.notifymode"+servernum, 0 ,'');
                    else if(prefs.prefHasUserValue("OGPlugin.settings.brighttradingally"))
                       notifymode = OGPlugin_getIntPref("OGPlugin.settings.notifymode", 0 ,'');
                      
                    //alert(httpRequest.getAllResponseHeaders());
                      
                    if (parHandleReadyState==true) 
                        HttpHandleResult = OGPlugin_HandleHttpRequestResult(temphttpstatus, temphttpresponse, notifymode);
                        //alert("httprequest state=4");
                    ogs_httprequestinprogress=false;
                    
                    if (ogs_sendmodedebug) {
                        alert(temphttpresponse);
                        OGPlugin_TrigDoc.getElementsByTagName('table')[0].innerHTML = temphttpresponse;
                    }
                    
                    return HttpHandleResult;        
                }
        
        }  
        
        function httponerror(e) {
            if(e != null)
            alert("Error (onhttperror) " + e.target.status + " occurred while receiving the document.");
        }

        if (ogs_debug_mode==true) alert("début OGPlugin_SendhttpRequest!");

        var paronload=0;
        ogs_httprequestinprogress=true;
        //alert("httprequest init");
        var httpRequest = new XMLHttpRequest();



        httpRequest.open("POST", parUrl, parASync); 
        httpRequest.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
        if (parogsclientmod === true) httpRequest.setRequestHeader("User-Agent", "OGSClient");
        httpRequest.setRequestHeader("Content-Length", parContent.length);       
        httpRequest.send(parContent);        
        
        /* if (prefs.prefHasUserValue("OGPlugin.settings.multisserversend") && 
            prefs.getBoolPref("OGPlugin.settings.multisserversend")==true) {
            paronload=0;
            httpRequest.onStateChange = function () { OGPlugin_PrepareToHandle();  };
        } else { */
        
            httpRequest.onload = function (e) { OGPlugin_PrepareToHandle(e); };

            httpRequest.onerror = function () { httponerror();  };
            paronload=1;
            
            
       // }      
        
 
        return HttpHandleResult;   
}

/**
 * Récupère les codes de retour de la requète http pour afficher un message à l'utilisateur
 * @param parhttprequeststatus
 * @param parhttprequestresponse
 * @param parnotifymode
 **/
function OGPlugin_HandleHttpRequestResult(parhttprequeststatus, parhttprequestresponse, parnotifymode) {
/* devra appeler une fonction adhoc suivant le jeu Ogame,EUnivers
   Ogame: OGPlugin_HandleOGSPYHttpRequestResult
   
   !!!!: ne pourra pas accepter des réponses de serveur de jeu Ogame/EUnivers différents sur une même instance du navigateur

*/
/*
                * Status Codes:
                - 200 = okay (but wrong page)
                - 403: forbidden
                - 404: page not found
		            - 405: 		- Response Text:
                - 701: galaxy view inserted
                - 702: problem with inserting galaxy view
                - 704: can't export systems to server
                - 711: report inserted
                - 712: at least one report was wrong
                - 714: can't export reports to server
                - 721: stats updated
                - 722: stats not updated
                - 723:
                - 724:
                - 725:
                - 731: allyhistory updated
                - 732: allyhistory not updated
                - 740: buildings page updated
                - 741: buildings page not updated
                - 742: buildings process error
                - 771: getcommand
                - 779: getcommandunknow;
                - 795: non concordance des noms d'univers
                - 796: recherche mode notification:
                - 799: function non implemented
                - 0 compléter
                */

                /**
                 * les codes retour pour Exile commenceront à 900
                 * ou devront être signalé par une variable dans la réponse
                 */

                /* if (LastServerPostError == true) { // failure
                    OGPlugin_SetStatusViewLabel("notify",OGPlugin_GetLocString("error.serverrequestskipped")+' ('+httpRequest.status+') [RT:'+httpRequest.responseText+']');
                    return 0;
                } */                

                var notifymodepref = parseInt(parnotifymode);

                // seulement pour httpheader 200,40n,50n
                var stdhttp_response_status = parseInt(parhttprequeststatus); // déclarable seulement si readystate=4

                // Détermination du code de réponse principal suivant le mode de notification
                if (notifymodepref==0 ) response_status = parseInt(parhttprequeststatus);
                else response_status = parseInt(parhttprequestresponse.substr(0,3)); // voir pour splitting, dans ce cas code numérique en premiÞre ligne
                //alert(parhttprequestresponse[0].substr(0,3)+"-"+parhttprequestresponse[0]+"-"+parhttprequestresponse[1]+"-"+parhttprequestresponse[2]);
                //
                if (ogs_onresponse_debug_mode==true) alert("status: "+response_status+", response: "+parhttprequestresponse+", notify mode: "+parnotifymode);

                // ###################### FIN / ANALYSE ET EXTRACTION DES MESSAGES DE REPONSES ADDITIONNELS #######################

                // décodage chaîne réponse, détection de mise à jour demandée
                try {
                    parhttprequestresponse=decodeURIComponent(parhttprequestresponse); // decodage de la chaîne
                } catch(e) {
                  OGPlugin_SetStatusViewLabel("nothingdone",ogspymsglabel+'La r\u00e9ponse du serveur n\'a pas pu etre interpret\u00e9e!\n'+parhttprequestresponse);
                  if (notifymodepref==0 ) return -1; // quitter si le code ne peut être récupérer dans parhttprequeststatus
                }
                // vérification notification demande mise Ó jour de la barre
                if (parhttprequestresponse.search("toolbar_needs_update")>-1) { /* <|===/-!-\===|> retiré */
                    OGPlugin_SetStatusViewLabel("nothingdone",ogspymsglabel+OGPlugin_GetLocString("error.pleaseupgrade")+servername_statusline);
                }

                // ################# ANALYSE ET EXTRACTION DES MESSAGES DE REPONSES ADDITIONNELS ########################

                // recherche rang serveur retransmis, sera intégré dans servername
                resp_serverrank = parhttprequestresponse.match(/resp_serverrank=([\w,\s]+)<?.*?$/);
                if (resp_serverrank) {
                    serverrank =  resp_serverrank[1];
                } else {
                    serverrank = '';
                }

                // Réponse du serveur/compte principal
                if (ogs_targetserverid==serverrank && response_status!=750 && response_status>=700) {
                    OGPlugin_SetStatusViewLabel("success",ogspymsglabel+' Le serveur principal contact\u00e9 a r\u00e9pondu positivement');
                }

                // recherche nom serveur
                resp_servername = parhttprequestresponse.match(/resp_servername=([\w,\s,\-,_,\.,\s,\!\',`]+)\S<?.*?$/);
                if (resp_servername) {
                    if (ogs_onresponse_debug_mode==true) alert("nom serveur:\n"+resp_servername+'rank serveur:\n'+resp_serverrank);
                    servername =  resp_servername[1];
                    if (resp_serverrank) servername += ' ('+serverrank+')';
                    servername_statusline = ' sur '+servername;
                } else {
                    servername = '';
                    if (serverrank!='') servername_statusline = ' sur serveur ('+serverrank+')';
                    else servername_statusline = '';
                }
                
                // recherche message texte avec code retour
                resp_message = parhttprequestresponse.match(/resp_message=([\w,\s]+)<?.*?$/);
                if (resp_message) {
                    if (ogs_onresponse_debug_mode==true) alert("nom serveur:\n"+resp_servername+'rank serveur:\n'+resp_serverrank);
                    servername =  resp_message[1];

                } else responsemessage = '';
                
                // recherche message réponse concernant rapports espionnages ennemi
                resp_enemyspy_tab = parhttprequestresponse.match(/resp_enemyspy=((\d+)\/(\d+)\/(\d+))<?.*?$/);
                if (resp_enemyspy_tab) {

                    enemyspy_total = parseInt(resp_enemyspy_tab[2]);
                    enemyspy_added = parseInt(resp_enemyspy_tab[3]);
                    enemyspy_existing = parseInt(resp_enemyspy_tab[4]);
                    
                    //alert("resp_enemyspy_tab: "+resp_enemyspy_tab+"\n\n"+enemyspy_total+"/"+enemyspy_added+"/"+enemyspy_existing);
                    
                    if (ogs_onresponse_debug_mode==true) alert("Rapports ennemis: "+enemyspy_total+"/"+enemyspy_added+"/"+enemyspy_existing);
                    // formattage du message à afficher
                    if (enemyspy_total>0 && (enemyspy_added > 0 || enemyspy_existing> 0)) {
                        enemyspy_respmsg = "Sur "+enemyspy_total+" rapport(s) d'espionnage ennemis, ";
                        if (enemyspy_added > 0) enemyspy_respmsg += enemyspy_added+" ont \u00e9t\u00e9 ins\u00e9r\u00e9s";
                        if (enemyspy_added > 0 && enemyspy_existing > 0) enemyspy_respmsg += " et ";
                        if (enemyspy_existing> 0) enemyspy_respmsg += enemyspy_existing+" existaient d\u00e9j\u00e0";
                        enemyspy_respmsg += servername_statusline;
                    } else {
                        if (enemyspy_total>0 && enemyspy_added == 0 && enemyspy_existing ==0)
                            enemyspy_respmsg = "Aucun rapport d'espionnage n'a \u00e9t\u00e9 trait\u00e9"+servername_statusline+"! ("+enemyspy_total+"/"+enemyspy_added+"/"+enemyspy_existing+")";
                        else enemyspy_respmsg = ""; // "Aucun rapport d'espionnage ennemi n'a \u00e9t\u00e9 trait\u00e9!";
                        
                    }

                } else { // mise à zéro
                    enemyspy_total = 0;
                    enemyspy_added = 0;
                    enemyspy_existing = 0;
                    enemyspy_respmsg = "";
                }
                
                // recherche message réponse concernant rapports de recyclage
                resp_recyreport_tab = parhttprequestresponse.match(/resp_recyreport=((\d+)\/(\d+)\/(\d+))<?.*?$/)
                if (resp_recyreport_tab) {

                    recyreport_total = parseInt(resp_recyreport_tab[2]);
                    recyreport_added = parseInt(resp_recyreport_tab[3]);
                    recyreport_existing = parseInt(resp_recyreport_tab[4]);
                    if (ogs_onresponse_debug_mode==true) alert("Rapports recyclage: "+recyreport_total+"/"+recyreport_added+"/"+recyreport_existing);
                    // formattage du message à afficher
                    if (recyreport_total>0) {
                        recyreport_respmsg = "Sur "+recyreport_total+" rapport(s) de recyclage, ";
                        if (recyreport_added>0) recyreport_respmsg += recyreport_added+" ont ete ins\u00e9r\u00e9s";
                        if (recyreport_added>0 && recyreport_existing>0) recyreport_respmsg += " et ";
                        if (recyreport_existing>0) recyreport_respmsg += recyreport_existing+" existaient d\u00e9j\u00e0"+servername_statusline;
                    } else recyreport_respmsg = ""; // "Aucun rapport de recyclage n'a ete trait\u00e9!";


                } else { // mise à zéro
                    recyreport_total = 0;
                    recyreport_added = 0;
                    recyreport_existing = 0;
                    recyreport_respmsg = "";
                }
                // affichage des messages supplémentaires à la fin du "switch(codestatus)"
                
                // Affichage des messages supplémentaires si le code de réponse principal concerne des rapports
                // doit être affiché après le message du code de réponse principal
                if (response_status>=711 && response_status<=716) {
                    if (recyreport_respmsg!='') OGPlugin_SetStatusViewLabel("nothingdone", recyreport_respmsg);
                    if (enemyspy_respmsg!='') OGPlugin_SetStatusViewLabel("nothingdone", enemyspy_respmsg);

                }
                
                
                
                // Détermination de l'affichage suivant le code de réponse principal
                if (stdhttp_response_status == 403) { // forbidden
                    OGPlugin_SetStatusViewLabel("failure",OGPlugin_GetLocString("error.permissiondenied"));
                    HHR_ResultCode =  0;
                } else if(stdhttp_response_status == 404) { // page not found
                    OGPlugin_SetStatusViewLabel("failure",OGPlugin_GetLocString("error.pagenotfound"));
                    HHR_ResultCode =  0;
                } else if(stdhttp_response_status == 405) { // Method Not Allowed
                    OGPlugin_SetStatusViewLabel("failure","Methode non autorisee");
                    HHR_ResultCode =  0;
                } else if((stdhttp_response_status == 500) && (notifymodepref==0)) { // Internal server error
                    OGPlugin_SetStatusViewLabel("failure",OGPlugin_GetLocString("error.httpinternalservererror")+', '+OGPlugin_GetLocString("error.pleaseretryagain"));
                    HHR_ResultCode =  0;
                } else if((stdhttp_response_status == 504) && (notifymodepref==0)) { // Internal server error
                    OGPlugin_SetStatusViewLabel("failure", "La passerelle reseau ne repond pas!");
                    HHR_ResultCode =  0;
                } else if(stdhttp_response_status == 200) { // status okay - but wrong page
                    OGPlugin_SetStatusViewLabel("failure",OGPlugin_GetLocString("error.wrongpage"));
                    HHR_ResultCode =  0;
                // Début Codes Retour OGSPY
                } else if(response_status == 701) { // ogspy gv updated                    
                    OGPlugin_SetStatusViewLabel("success",ogspymsglabel+OGPlugin_responsetext+servername_statusline);
                    HHR_ResultCode =  1;
                } else if(response_status == 702) { // ogs gv not updated
                    OGPlugin_SetStatusViewLabel("failure",ogspymsglabel+OGPlugin_GetLocString("error.gvnotupdated")+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 704) { // can't export systems to server -
                    OGPlugin_SetStatusViewLabel("failure",ogspymsglabel+ OGPlugin_GetLocString("error.cantexportgalaxy")+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 705) { // galaxy buffer updated
                    OGPlugin_SetStatusViewLabel("success",ogspymsglabel+ OGPlugin_GetLocString("galbufferupdated")+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 706) { // galaxy buffer not updated
                    OGPlugin_SetStatusViewLabel("failure",ogspymsglabel+ OGPlugin_GetLocString("galbuffernotupdated")+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 707) { // galaxy buffer partially updated
                    OGPlugin_SetStatusViewLabel("nothingdone",ogspymsglabel+ OGPlugin_GetLocString("galbufferpartiallyupdated")+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 707) { // galaxy buffer partially updated
                    OGPlugin_SetStatusViewLabel("nothingdone",ogspymsglabel+ OGPlugin_GetLocString("galbufferpartiallyupdated")+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 710) { // sera utilisé pour la réponse asynchrone des commande du module OGS Plugin
                    OGPlugin_SetStatusViewLabel("nothingdone",ogspymsglabel+ "R\u00e9ception de r\u00e9sultat de commande"+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 711) { // ogs report inserted
                    OGPlugin_SetStatusViewLabel("success",ogspymsglabel+OGPlugin_responsetext+servername_statusline);
                    HHR_ResultCode =  1;
                } else if(response_status == 712) { // ogs at least 1 report not inserted
                    OGPlugin_SetStatusViewLabel("nothingdone",ogspymsglabel+OGPlugin_GetLocString("error.reportatleasterror")+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 713) { // aucun rapport d'espionnage n'a été inséré
                    OGPlugin_SetStatusViewLabel("failure",ogspymsglabel+OGPlugin_GetLocString("error.noreporterror")+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 714) { // can't export espio report to server
                    OGPlugin_SetStatusViewLabel("failure",ogspymsglabel+OGPlugin_GetLocString("error.cantexportreports")+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 715) { // tous les rapports existaient déjà sur
                    OGPlugin_SetStatusViewLabel("nothingdone",ogspymsglabel+"Les rapports existaient d\u00e9j\u00e0"+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 716) { // aucun rapports d'espionnages traité mais des rapports d'espionnage ennemis ou de recyclage
                    OGPlugin_SetStatusViewLabel("success",ogspymsglabel+"Des traitements de rapports autres ont \u00e9t\u00e9 effectu\u00e9s "+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 721) { // ogs stats updated
                    OGPlugin_SetStatusViewLabel("success",ogspymsglabel+OGPlugin_responsetext+servername_statusline);
                    HHR_ResultCode =  1;
                } else if(response_status == 722) { // ogs stats not updated
                    OGPlugin_SetStatusViewLabel("failure",ogspymsglabel+OGPlugin_GetLocString("error.statserror")+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 723) { // ogs stats sent
                    OGPlugin_SetStatusViewLabel("success",ogspymsglabel+OGPlugin_responsetext+servername_statusline);
                    HHR_ResultCode =  1;
                } else if(response_status == 724) { // can't export rankink stats to server - forbidden
                    OGPlugin_SetStatusViewLabel("failure",ogspymsglabel+OGPlugin_GetLocString("error.cantexportstats")+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 725) { // at least on stat ranking line not updated
                    OGPlugin_SetStatusViewLabel("nothingdone",ogspymsglabel+OGPlugin_GetLocString("error.onestatlineignored")+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 726) { // stats already updated
                    OGPlugin_SetStatusViewLabel("nothingdone",ogspymsglabel+OGPlugin_GetLocString("statslabel.prefix")+response_Whoname+" "+OGPlugin_selectedRanks+OGPlugin_GetLocString("statsalreadyupdated.suffix")+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 727) { // stats buffer updated
                    OGPlugin_SetStatusViewLabel("success",ogspymsglabel+OGPlugin_GetLocString("statsbufferupdated")+servername_statusline);
                    HHR_ResultCode =  1;
                } else if(response_status == 728) { // stats buffer not updated
                    OGPlugin_SetStatusViewLabel("failure",ogspymsglabel+OGPlugin_GetLocString("error.statsbuffernotupdated")+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 729) { // stats buffer partially updated
                    OGPlugin_SetStatusViewLabel("nothingdone",ogspymsglabel+OGPlugin_GetLocString("statsbufferpartiallyupdated")+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 730) { // stats buffer already updated
                    OGPlugin_SetStatusViewLabel("nothingdone",ogspymsglabel+OGPlugin_GetLocString("statsbufferalreadyuptodate")+servername_statusline);
                    HHR_ResultCode =  0; // voir code 730 données du tampon déjÓ Ó jour
                } else if(response_status == 731) { // allyhistory updated
                    OGPlugin_SetStatusViewLabel("success",ogspymsglabel+OGPlugin_responsetext+" ("+AllyTAGFound+")"+servername_statusline);
                    HHR_ResultCode =  1;
                } else if(response_status == 732) { // allyhistory not updated
                    OGPlugin_SetStatusViewLabel("failure",ogspymsglabel+OGPlugin_GetLocString("error.allyhistoryerror")+" ("+AllyTAGFound+")"+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 733) { //  allyhistory already uptodate
                    if (AllyTAGFound!="undefined" || AllyTAGFound!="")
                    OGPlugin_SetStatusViewLabel("nothingdone",ogspymsglabel+OGPlugin_GetLocString("error.allystatsuptodate")+" ("+AllyTAGFound+")"+servername_statusline);
                    else OGPlugin_SetStatusViewLabel("nothingdone",ogspymsglabel+OGPlugin_GetLocString("error.allystatsuptodate")+" ("+OGPlugin_GetLocString("error.allyundefined")+")");
                    HHR_ResultCode =  0;
                 
                } else if(response_status == 735) { // fleet updated
                    OGPlugin_SetStatusViewLabel("success","Flotte mise \u00e0 jour pour "+PlanetNameWithCoords+servername_statusline);
                    HHR_ResultCode =  1;
                } else if(response_status == 736) { // fleet not updated
                    OGPlugin_SetStatusViewLabel("failure","Flotte non mise \u00e0 jour pour "+PlanetNameWithCoords+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 737) { // fleet not updated
                    OGPlugin_SetStatusViewLabel("failure","Page flotte incorrecte pour "+PlanetNameWithCoords+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 739) { // ally stats buffer partially updated
                    OGPlugin_SetStatusViewLabel("failure",ogspymsglabel+OGPlugin_GetLocString("error.allyhistoryerror")+" ("+AllyTAGFound+")");
                    HHR_ResultCode =  0;
                } else if(response_status == 740) { // buildings page updated
                    OGPlugin_SetStatusViewLabel("success",OGPlugin_GetLocString("buildingpageupdated")+OGPlugin_GetLocString("planettranfertinfix")+PlanetNameWithCoords+servername_statusline);
                    HHR_ResultCode =  1;
                } else if(response_status == 741) { // buildings page not updated
                    OGPlugin_SetStatusViewLabel("failure",OGPlugin_GetLocString("buildingpagenotupdated")+OGPlugin_GetLocString("planettranfertinfix")+PlanetNameWithCoords+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 742) { // erreur lors traitement, données bÔtiments ignorée
                    OGPlugin_SetStatusViewLabel("nothingdone",OGPlugin_GetLocString("error.buildingpageskipped")+OGPlugin_GetLocString("planettranfertinfix")+PlanetNameWithCoords+servername_statusline); //"Erreur lors du traitement de la page batiments, donnees incorrectes";
                    HHR_ResultCode =  1;
                } else if(response_status == 743) { // first need inserting main building page for ....
                    OGPlugin_SetStatusViewLabel("nothingdone",OGPlugin_GetLocString("error.rootplanetneeded")+OGPlugin_GetLocString("planettranfertinfix")+PlanetNameWithCoords+servername_statusline); // OGPlugin_GetLocString("error.buildingpageskipped"); //"Erreur lors du traitement de la page batiments, donnees incorrectes";
                    HHR_ResultCode =  0;
                } else if(response_status == 745) { // impossible d'insérer données batiments, coordonnées inconnus ou pas d'emplacement disponible (1->9 / 10->18)
                    OGPlugin_SetStatusViewLabel("failure",OGPlugin_GetLocString("error.buildingslotsfull")+servername_statusline); //"Empire déjÓ complet ou coordonnees inconnues!";
                    HHR_ResultCode =  0;
                // gestion codes page technos
                } else if(response_status == 746) { // technos data inserted
                    OGPlugin_SetStatusViewLabel("success",OGPlugin_GetLocString("technospageupdated")+OGPlugin_GetLocString("planettranfertinfix")+PlanetNameWithCoords+servername_statusline); //OGPlugin_GetLocString("error.buildingpageskipped"); //"Erreur lors du traitement de la page batiments, donnees incorrectes";
                    HHR_ResultCode =  1;
                } else if(response_status == 747) { // technos data not inserted
                    OGPlugin_SetStatusViewLabel("failure",OGPlugin_GetLocString("technospagenotupdated")+OGPlugin_GetLocString("planettranfertinfix")+PlanetNameWithCoords+servername_statusline); // OGPlugin_GetLocString("error.buildingpageskipped"); //"Erreur lors du traitement de la page batiments, donnees incorrectes";
                    HHR_ResultCode =  0;
                } else if(response_status == 748) { // erreur lors traitement page techno
                    OGPlugin_SetStatusViewLabel("failure",OGPlugin_GetLocString("error.technospageskipped")+servername_statusline); //"Erreur lors du traitement de la page techno, donnees incorrectes";
                    HHR_ResultCode =  0;
                } else if(response_status == 750) { // mysqldb not available
                    OGPlugin_SetStatusViewLabel("failure",ogspymsglabel+OGPlugin_GetLocString("error.sqldbnotready")+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 751) { // at least one sql request not treated
                    OGPlugin_SetStatusViewLabel("notify",ogspymsglabel+OGPlugin_GetLocString("error.sqlquerycanceled")+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 752) { // authentification failed
                    OGPlugin_SetStatusViewLabel("failure",ogspymsglabel+OGPlugin_GetLocString("error.authentificationfailed")+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 753) { // login / password missing
                    OGPlugin_SetStatusViewLabel("failure",ogspymsglabel+OGPlugin_GetLocString("error.loginpwdmissing")+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 754) { // can't import from serveur, export to server
                    OGPlugin_SetStatusViewLabel("failure",ogspymsglabel+OGPlugin_GetLocString("error.cantexporttoserver")+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 755) { // account inactive
                    OGPlugin_SetStatusViewLabel("failure",ogspymsglabel+OGPlugin_GetLocString("error.inactiveaccount")+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 756) { // ogs connection forbidden
                    OGPlugin_SetStatusViewLabel("failure",ogspymsglabel+OGPlugin_GetLocString("error.ogslogdisabled")+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 757) { // commande inconnue
                    OGPlugin_SetStatusViewLabel("nothingdone",ogspymsglabel+OGPlugin_GetLocString("error.ogscommandunknown")+servername_statusline);
                    HHR_ResultCode =  0;
                //-----------------------------------------
                } else if(response_status == 760) { // shipyard data updated for ...  // chantier spatial
                    OGPlugin_SetStatusViewLabel("success",OGPlugin_GetLocString("shipyardpageupdated")+OGPlugin_GetLocString("planettranfertinfix")+PlanetNameWithCoords+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 761) { // shipyard data not updated    // chantier spatial
                    OGPlugin_SetStatusViewLabel("failure",OGPlugin_GetLocString("shipyardpagenotupdated")+OGPlugin_GetLocString("planettranfertinfix")+PlanetNameWithCoords+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 765) { // defence data updated for
                    OGPlugin_SetStatusViewLabel("success",OGPlugin_GetLocString("defencepageupdated")+OGPlugin_GetLocString("planettranfertinfix")+PlanetNameWithCoords+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 766) { // defence data not updated
                    OGPlugin_SetStatusViewLabel("failure",OGPlugin_GetLocString("defencepagenotupdated")+OGPlugin_GetLocString("planettranfertinfix")+PlanetNameWithCoords+servername_statusline);
                    HHR_ResultCode =  0;
                //--------------------------------------------------
                } else if(response_status == 770) { // planet empire updated
                    OGPlugin_SetStatusViewLabel("success", OGPlugin_GetLocString("planetspageprocessed")+servername_statusline);
                    HHR_ResultCode =  1;
                } else if(response_status == 771) { // planet empire not updated
                    OGPlugin_SetStatusViewLabel("failure", OGPlugin_GetLocString("error.planetspagenotprocessed")+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 773) { // eunivers global view updated
                    OGPlugin_SetStatusViewLabel("success", OGPlugin_GetLocString("empireglobalviewprocessed")+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 774) { // eunivers global view not updated
                    OGPlugin_SetStatusViewLabel("failure", OGPlugin_GetLocString("error_empireglobalviewprocessed")+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 775) { // moon empire updated
                    OGPlugin_SetStatusViewLabel("success", OGPlugin_GetLocString("moonspageprocessed")+servername_statusline);
                    HHR_ResultCode =  1;
                } else if(response_status == 776) { // moon empire not updated
                    OGPlugin_SetStatusViewLabel("failure", OGPlugin_GetLocString("error.moonspagenotprocessed")+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 777) { // infos planète mises à jour: temp, diam, case util / max cases
                    OGPlugin_SetStatusViewLabel("success", "Caract\u00e9ristiques de plan\u00e8te/lune mises \u00e0 jour pour "+PlanetNameWithCoords+servername_statusline);
                    HHR_ResultCode =  1;
                } else if(response_status == 778) { // infos planète non mises à jour
                    OGPlugin_SetStatusViewLabel("failure", "Caract\u00e9ristiques de plan\u00e8te/lune non mises \u00e0 jour pour "+PlanetNameWithCoords+servername_statusline);
                    HHR_ResultCode =  0;
                //-------------------------------------
                } else if(response_status == 780) { // page galaxie non gérée/acceptée sur le serveur
                    OGPlugin_SetStatusViewLabel("nothingdone", OGPlugin_GetLocString("error.galviewsnothandledonserver")+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 781) { // page stats joueurs non gérée/acceptée sur le serveur
                    OGPlugin_SetStatusViewLabel("nothingdone", OGPlugin_GetLocString("error.playerstatsnothandledonserver")+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 782) { // page stats alliances non gérées/acceptées sur le serveur
                    OGPlugin_SetStatusViewLabel("nothingdone", OGPlugin_GetLocString("error.allystatsnothandledonserver")+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 783) { // rapports non gérés/acceptés sur le serveur
                    OGPlugin_SetStatusViewLabel("nothingdone", OGPlugin_GetLocString("error.reportsnothandledonserver")+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 785) { // ogs stats hours not handled - créneau horaire non géré
                    OGPlugin_SetStatusViewLabel("failure",ogspymsglabel+OGPlugin_GetLocString("error.statstimetiblenothandled")+servername_statusline);
                    HHR_ResultCode =  1;
                } else if(response_status == 790) { // script de de liaison OGS en maintenance -
                    OGPlugin_SetStatusViewLabel("nothingdone",ogspymsglabel+OGPlugin_GetLocString("error.ogsphpscriptoff")+" - "+OGPlugin_GetLocString("error.permissiondenied")+servername_statusline);
                    HHR_ResultCode =  0;
                } else if(response_status == 791) { // mise à jour de la barre d'outils demandée
                    OGPlugin_SetStatusViewLabel("nothingdone",ogspymsglabel+OGPlugin_GetLocString("error.toolbarupgradeneeded")+OGPlugin_GetLocString("error.ogamedataupdateaborted")+servername_statusline);
                    // code mise Ó jour automatique barre d'outils
                    if (OGPlugin_getBoolPref('OGPlugin.settings.modresponseaskupdatecheck', true, 'OGPlugin-modresponseaskupdatecheck')==true)
                        if (confirm("V\u00e9rifier si une mise \u00e0 jour est disponible?")==true) OGPlugin_UpdateToolbar(true, true, false);
                    HHR_ResultCode =  0;
                }  else if(response_status == 792) { // décocher option réduire page galaxie ou désactiver foxgame
                    OGPlugin_SetStatusViewLabel("nothingdone",ogspymsglabel+ OGPlugin_GetLocString("error.disablefggalopt"));
                    // afficher boite dialogue
                    if (OGPlugin_getBoolPref("OGPlugin.settings.autoshowfgoptions", false, '') == true)  {
                       tempstring1 = OGPlugin_GetLocString("error.incorrecthtmldataformat");
                       tempstring2 = OGPlugin_GetLocString("error.justsetfoxgaloff");
                       tempstring3 = OGPlugin_GetLocString("error.showfxgoptions");
                       if (confirm(tempstring1+"\n\n"+tempstring2+"\n\n"+tempstring3)) {
                          //action Ó faire pour la valeur true
                          OGPlugin_ShowFoxgameOptions(0);
                       }
                    }
                    HHR_ResultCode =  0;
                } else if(response_status == 793) { // la page du jeu envoyée n'est pas celle attendue par le serveur (eg page ogame sur serveur e-univers)
                    OGPlugin_SetStatusViewLabel("failure","Le jeu sur lequel vous \u00eates connect\u00e9 ne correspond pas a celui du serveur"+servername_statusline);
   
                    HHR_ResultCode =  0;
                } else if(response_status == 794) { // server down
                    
                    // déplacé en entÛte
                    //parhttprequestresponse=decodeURIComponent(parhttprequestresponse);
                    // séparateur : '<|===/\-!\-\\===|>'
                    //var regsplit=new RegExp("(<|>)\|===/\\\-!\\\-\\\\===\|(<|>)", "g");
                    parhttprequestresponse=OGPlugin_RemoveJavaScriptTags(parhttprequestresponse);
                    var serverdownresponse  = parhttprequestresponse.split('<|===/\-!\-\\===|>'); 
                    OGPlugin_SetStatusViewLabel("nothingdone",ogspymsglabel+ OGPlugin_GetLocString("error.serverdown")+" : "+serverdownresponse[1]);
                    HHR_ResultCode =  0;
                }  else if(response_status == 795) { // requête envoyée à un serveur pour un serveur de jeu non attendu
                    OGPlugin_SetStatusViewLabel("failure",OGPlugin_GetLocString("error.wronguniversedatas")+servername_statusline);
                    HHR_ResultCode =  0;
                }  else if(response_status == 796) { // module OGS Plugin non actif sur le serveur distant
                    OGPlugin_SetStatusViewLabel("failure","Module OGS Plugin d\u00e9sactiv\u00e9"+servername_statusline);
                    HHR_ResultCode =  0;
                }  else if(response_status == 797) { // développement indicateur de variable $pub_typ manquante dans le code php du module
                    parhttprequestresponse=OGPlugin_RemoveJavaScriptTags(parhttprequestresponse);
                    if (parhttprequestresponse.search('<|===/\-!\-\\===|>')>-1) {
                        var mod_errormessage  = parhttprequestresponse.split('<|===/\-!\-\\===|>');
                        OGPlugin_SetStatusViewLabel("failure",ogspymsglabel+mod_errormessage[1]);
                    } else {
                        OGPlugin_SetStatusViewLabel("failure",ogspymsglabel+parhttprequestresponse);
                    
                    }
                    //Calert(parhttprequestresponse);
                    HHR_ResultCode =  0;
                }  else if(response_status == 798) { // l'adresse du script de liaison a changé
                    //parhttprequestresponse=decodeURIComponent(parhttprequestresponse); // déplacé en entÛte
                    parhttprequestresponse=OGPlugin_RemoveJavaScriptTags(parhttprequestresponse);
                    var scripthasmoved  = parhttprequestresponse.split('<|===/\-!\-\\===|>');
                    OGPlugin_SetStatusViewLabel("nothingdone","L'adresse du script a chang\u00e9 "+servername_statusline+": "+scripthasmoved[1]);
                    HHR_ResultCode =  0;
                }  // messages de retour des rapports de combat
                   else if(response_status == 799) { // fonction non implementée                    
                    OGPlugin_SetStatusViewLabel("nothingdone",ogspymsglabel+ OGPlugin_GetLocString("error.unimplementedfunction")+servername);
                    HHR_ResultCode =  0;
                }  else if(response_status == 800) { // si mod non activé                    
                    OGPlugin_SetStatusViewLabel("failure",ogspymsglabel+ OGPlugin_GetLocString("combreport_inactivemod")+servername_statusline);
                    HHR_ResultCode =  0;
                }  else if(response_status == 801) { //  Rapport de combat non valide                 
                    OGPlugin_SetStatusViewLabel("failure",ogspymsglabel+OGPlugin_GetLocString("combreport_invalidcombreport")+servername_statusline);
                    HHR_ResultCode =  0;
                }  else if(response_status == 802) { // Vous n'Ûtes pas l'attaquant du rapport de combat!                  
                    OGPlugin_SetStatusViewLabel("failure",ogspymsglabel+OGPlugin_GetLocString("combreport_playernicknotowner"));
                    HHR_ResultCode =  0;
                }  else if(response_status == 803) { // Rapport de Combat d\u00e9j\u00e0 enregistr\u00e9                     
                    OGPlugin_SetStatusViewLabel("nothingdone",ogspymsglabel+OGPlugin_GetLocString("combreport_alreadysaved")+servername_statusline);
                    HHR_ResultCode =  0;
                }  else if(response_status == 804) { // Rapport de combat pris en compte                     
                    OGPlugin_SetStatusViewLabel("success",ogspymsglabel+OGPlugin_GetLocString("combreport_wellsaved")+servername_statusline);
                    HHR_ResultCode =  0;
                }  else if(response_status == 810) { // Interruption du script OGS Plugin pendant l'appel d'une fonction tierce
                    OGPlugin_SetStatusViewLabel("failure","Un module n'a pas rendu la main alors qu'il importait des donn\u00e9es"+servername_statusline);
                    HHR_ResultCode =  0;
                } else {
                    OGPlugin_SetStatusViewLabel("failure",OGPlugin_GetLocString("error.badstatuscode")+response_status+"("+ parhttprequestresponse+") "+OGPlugin_GetLocString("error.pleaseupgrade"));
	                  HHR_ResultCode =  0;
                }
                
                
                return HHR_ResultCode;

}

/**
 * Fonction appelée quand l'utilisateur clique sur le bouton activer
 **/
function OGPlugin_Activate() {
    if (OGPlugin_activated == 0) {
        OGPlugin_activated = 1;
        document.getElementById("OGPlugin-activate").setAttribute("tooltiptext", OGPlugin_GetLocString("toolbar.deactivate.t"), 0);
        document.getElementById("OGPlugin-activate").setAttribute("label", OGPlugin_GetLocString("toolbar.deactivate"), 0);
        document.getElementById("OGPlugin-activate").setAttribute("image", "chrome://ogsplugin/skin/images/disable.gif", 0);
        OGPlugin_SetStatusViewLabel("notify",OGPlugin_GetLocString("toolbar.deactivate.status"));
//        window.addEventListener("load", init, true);
    } else {
        OGPlugin_activated = 0;
        document.getElementById("OGPlugin-activate").setAttribute("tooltiptext", OGPlugin_GetLocString("toolbar.activate.t"), 0);
        document.getElementById("OGPlugin-activate").setAttribute("label", OGPlugin_GetLocString("toolbar.activate"), 0);
        document.getElementById("OGPlugin-activate").setAttribute("image", "chrome://ogsplugin/skin/images/enable.gif", 0);
        OGPlugin_SetStatusViewLabel("notify",OGPlugin_GetLocString("toolbar.activate.status"));
//        window.removeEventListener("load", init, true);
    }
}

/**
 * Fonctionne permettant de d'activer le bouton d'envoi de page en modifidant son état actif et son aspect
 * suivant la valeur de SendButtonPage.
 * @author Naqdazar
 * @param SendButtonPage (String) Chaîne indiquant la catagorie texte et icône à appliquer au bouton suivant la page détectée
 *                                peut être nul pour désactiver le bouton.
 * @param EnableSendButton (boolean) booléan indiquant l'état actif ou pas du bouton.
 */
function OGPlugin_SetSendButtonLabel(SendButtonPage, EnableSendButton)
{
   if (SendButtonPage!='') SendButtonActionCmd = SendButtonPage;
   //alert(SendButtonActionCmd);
   var targetbutton = document.getElementById("OGPlugin-reports");
   if (targetbutton != null) {
       if (SendButtonPage!='') {
           targetbutton.label = OGPlugin_GetLocString("toolbar."+SendButtonPage);
           targetbutton.setAttribute("tooltiptext", OGPlugin_GetLocString("toolbar."+SendButtonPage+".t"));
           targetbutton.image="chrome://ogsplugin/skin/images/"+SendButtonPage+".gif";
       }
       
       if (EnableSendButton==true) {
          targetbutton.disabled = false;
          if (OGPlugin_IsNCSStringEquals(SendButtonActionCmd, 'reports')==true) {
               targetbutton.setAttribute('context', 'ogsplugin-ondemandcapture');
          } else targetbutton.setAttribute('context', '');
       } else {
          targetbutton.disabled = true;
          targetbutton.setAttribute('context', '');
       }
   } else alert('Erreur: OGPlugin_SetSendButtonLabel!');
}


/**
 * fonction appelée lors d'un clic sur un element de menu contextuel accélérateur (ogspy)
 * @param nummenuitem : indice de l'élément de menu cliqué
 */
function OGPlugin_OGSTagMenuExec(nummenuitem)
{   var targeturl="";
    if (nummenuitem==8) { // id dernier élément: ouverture autre page Ogame
       var currenturl = CurrentDocUrl;

       const head_pattern = new RegExp("http\:\/\/.*?\/game\/","g");
       //var targeturlhead = targeturlhead.match(head_pattern);
       var targeturlhead = head_pattern.exec(currenturl);
       //document.getElementById("OGPlugin-status-view").value ="apres head "+targeturlhead;
       var tail_pattern = new RegExp("/\?session\=[a-z,A-Z,0-9]{10,16}","");
       //document.getElementById("OGPlugin-status-view").value ="apres head regexp "+targeturl;
       var targeturltail = tail_pattern.exec(currenturl);
       //document.getElementById("OGPlugin-status-view").value ="tail patterns: "+targeturl+"/"+targeturltail;

       if ( targeturlhead !=null && targeturltail!=null) {
          targeturl=targeturlhead+"index.php?"+targeturltail;
          //alert(targeturl);
          OGPlugin_SetStatusViewLabel("notify",OGPlugin_GetLocString("openingnewogamepg"));          
       } else {
              alert(OGPlugin_GetLocString("error.cantopennewogamepg"));
         return 0;
       }
    } else
    {
         if (document.getElementById("ogspytag-popup"+nummenuitem).getAttribute("disabled")=="true")
         {
           alert(OGPlugin_GetLocString("error.nomenuactionset")+"("+nummenuitem+")");
           return 0;
         }
         //targeturl = OGPlugin_getCharPref("OGPlugin.settings.url"+nummenuitem , '' ,'');
         targeturl = OGPlugin_GetOGSPYUrl(nummenuitem, false);
         lservername = OGPlugin_getCharPref("OGPlugin.settings.servername"+nummenuitem, '', '');

         pattern = new RegExp("ogsplugin?[0-9]{0,2}.php","g");

         // on récupÞre l'adresse qui doit se terminer par index.php
         targeturl = targeturl.replace(pattern, "index.php");

         OGPlugin_SetStatusViewLabel("notify",OGPlugin_GetLocString("openinghtmlpage")+lservername+'('+nummenuitem+')');
         targetlogin = decodeURIComponent(OGPlugin_getCharPref("OGPlugin.settings.username"+nummenuitem , '' ,''));
         targetpassword = OGPlugin_getCharPref("OGPlugin.settings.password"+nummenuitem , '' ,'');

         
         crypted = OGPlugin_getBoolPref('OGPlugin.settings.iscryptedpass'+nummenuitem, false, '');
         if (crypted==false) {
            var txtCommand = "action=login_web&login="+targetlogin+"&password="+targetpassword;
            // postage des identifiants pour qu'elles n'apparaissent pas dans la barre d'adresse
            var GChttpRequest = new XMLHttpRequest(); 
            GChttpRequest.open("POST", targeturl, false); // 3. Parameter ist f++r asynchronen Transfer n+Âtig
            GChttpRequest.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");            
            GChttpRequest.setRequestHeader("Content-Length", txtCommand.length);
            GChttpRequest.send(txtCommand);             
         }
    }
    
    // authentification non cryptée, si mot de passe non crypté dans les propriétés de la barre
    
    //window.openDialog('chrome://browser/content', 'Phoenix', 'chrome,all,dialog=no', txtCommand);
    tabBmkMan = getBrowser().addTab();
    getBrowser().selectedTab = tabBmkMan;    
    loadURI(targeturl);
}

/**
 * Prépare l'affichage du menu contextuel du bouton menu "OGSPY"
 */
function OGPlugin_OGSTagMenuLabelsInit()
{  // initialisation du menu ogspy, étiquette->nom serveur ogspy détectée

   var targetmenuitem;

   for(cpt=1;cpt<8;cpt++) { // traitement de touts les éléments menu
      targetmenuitem = document.getElementById("ogspytag-popup"+cpt);
      if (prefs.prefHasUserValue("OGPlugin.settings.servername"+cpt) &&
          OGPlugin_getCharPref("OGPlugin.settings.url"+cpt, '', '')!="") {
         targetlabel = OGPlugin_getCharPref("OGPlugin.settings.servername"+cpt , '' ,'');
         //alert(targetlabel);
         if (OGPlugin_TrimString(targetlabel)!="") {
            targetmenuitem.label = cpt+": "+targetlabel;
            targetmenuitem.setAttribute("disabled", false);
            targeturl=OGPlugin_getCharPref("OGPlugin.settings.url"+cpt , '' ,'');
            targetmenuitem.setAttribute("tooltiptext", targeturl);
         }
      } else targetmenuitem.setAttribute("disabled", true);
   }
}

/**
 * Ouvre le portail du forum de support dans un nouvel onglet
 */
function OGPlugin_BrowseSupportForum()
{
    tabBmkMan = getBrowser().addTab();
    getBrowser().selectedTab = tabBmkMan;    
    loadURI(supportforum_urlstring);
}

/**
 * Ouvre le fichier du tutoriel dans un nouvel onglet
 */
function OGPlugin_BrowseTutorialLink()
{
    tabBmkMan = getBrowser().addTab();
    getBrowser().selectedTab = tabBmkMan;    
    loadURI(/*OGPlugin_GetLocString("tutorialurl")*/'http://forum.e-univers.org/index.php?showtopic=20692');
}

/**
 * Fonction destinée à cacher un élement de menu à partir de son identifiant
 * @param MenuId chaîne: référence id de l'élement de menu à cacher.
 **/
function OGPlugin_HideMenu(MenuId) {
    document.getElementById(MenuId).hidePopup();
}

/**
 * Fonction appelée quand l'utilisateur clique sur le bouton de vidage des tampons
 **/
function OGPlugin_FlushBuffers_OnClick() {

     /* 1 elem neutre multiplication */
     var res_envoi=1, res_envoi_group=1; // laissé tel que mais obsolÞte
     
     // moditication des propriétés du bouton Envoyer
     OGPlugin_SetFlushButtonState(false);
           
     OGPlugin_SetStatusViewLabel("notify", OGPlugin_GetLocString("sendingbuffers"));

     // Envoi du tampon de vues galaxies
     if (Curr_GalViewBufCount>0)
        OGPlugin_sendText("galaxy",GalViewsBuffer,OGPlugin_TrigDoc.location.href);
     GalViewsBuffer="";
     Curr_GalViewBufCount=0;

     for (cptwho=0;cptwho<2;cptwho++) {
             //OGPlugin_selectedWho=cptwho;
             for (cptwhat=0;cptwhat<3;cptwhat++) {
                  //OGPlugin_selectedTyp=cptwhat;
  
                  if (Curr_StatBufCount[cptwho][cptwhat]>0) {
                      // vérifier envoi ok
                      res_envoi = OGPlugin_sendText("stats",StatsArrayBuffer[cptwho][cptwhat],OGPlugin_TrigDoc.location.href);                      
                      res_envoi_group*=res_envoi;
                      // si ok, on vide l'indiceur du tampon
                      //if (res_envoi==1) { // effacement tampon -> pb envoi who=0 what=0, resultat OGPlugin_sendText inconnu pour tampon
                          Curr_StatBufCount[cptwho][cptwhat]=0;
                          StatsArrayBuffer[cptwho][cptwhat]="";
                      //}    
                  }    
                  //if (ogs_debug_mode==true) alert("AprÞs vidage tampon\nQui: "+cptwho+"\nquoi: "+cptwhat+"\ntampon: "+StatsArrayBuffer[cptwho][cptwhat]);
             }     
     }        
    if (res_envoi_group!=0) OGPlugin_SetStatusViewLabel("notify", OGPlugin_GetLocString("partialbufferssent"));      
}

/**
 * Définit l'état activé ou désactivé du bouton de vidage des tampons
 */
function OGPlugin_SetFlushButtonState(stateenabled) {
     // moditication des propriétés du bouton Envoyer
     flushbuffers_button = document.getElementById("OGPlugin-flushbuffers");
     flushbuffers_button.disabled = !stateenabled;
     if (stateenabled) flushbuffers_button.image="chrome://ogsplugin/skin/images/flushena.gif";
     else flushbuffers_button.image="chrome://ogsplugin/skin/images/flushdis.gif";
}

/**
 * Définit le message qui s'affiche sur la barre d'outils et ajoute une entrée correspondante dans le journal
 * @param statetext chaîne: définit la catégorie du message par une couleur distincte choisie
 * @param labeltext chaîne: represente le message à afficher
 **/
function OGPlugin_SetStatusViewLabel(statetext, labeltext) {
    // OGPlugin_GetLocString( "toolbar.status.nothing" )
    
    // lecture de la taille du journal
    ogs_StatusLabelsHistoryLenght = OGPlugin_getIntPref('OGPlugin.settings.logsize', 50, 'OGPlugin-logsize');
    
    if ((labeltext!=ogs_laststatuslabel) || (ogs_laststatuslabel == OGPlugin_GetLocString( "toolbar.status.nothing" ) && labeltext != ogs_laststatuslabel)) {
        var targetlabel = document.getElementById("OGPlugin-status-view");

        if (statetext=="notify") targetlabel.setAttribute("style", "padding-top:3px; color:blue;");
        else if (statetext=="success") targetlabel.setAttribute("style", "padding-top:3px; color:green;");
        else if (statetext=="failure") targetlabel.setAttribute("style", "padding-top:3px; color:red;");
        else if (statetext=="nothingdone") targetlabel.setAttribute("style", "padding-top:3px; color:darkorange;");
        targetlabel.value = labeltext;
        targetlabel.setAttribute("tooltiptext", labeltext);
        ogs_laststatuslabel = labeltext;

        // si le journal dépasse la limite fixée, on retire les entrées les plus anciennes.
        while (ogs_StatusLabelsHistory.length > ogs_StatusLabelsHistoryLenght) ogs_StatusLabelsHistory.shift();
        var labeltext_date = new Date();

        // ajout message en fin de liste
        ogs_StatusLabelsHistory.push(labeltext_date.toLocaleString()+" : "+labeltext);
        //alert("OGPlugin_SetStatusViewLabel: "+ogs_StatusLabelsHistory.length+"-"+ogs_StatusLabelsHistory.join("\r\n"));
    }
}

/**
 * Méthode événementielle du menu contextuel associé au bouton "Envoyer"
 * @param reportscat entier representatant la catégorie de rapports à capturer 1|2|4
 */
function OGPlugin_SendReportsByCat_OnClick(reportscat) {

        var messageElements = OGPlugin_GetReportsByCat(reportscat, OGPlugin_TrigDoc);

        if(ogs_getreportsdebug_mode==true) {
           if (messageElements != null)
              OGPlugin_CopyToClipboard(messageElements);
           alert(messageElements);
        }

        if (messageElements != '' && messageElements != null && messageElements != false) {
            // filtrage des points de nombre
            if (OGPlugin_getBoolPref('OGPlugin.settings.filterpointsnumber', true, '')==true)
                messageElements = OGPlugin_FilterNumberPoints(messageElements);

            // filtrage des rapports suivant les options choisies
            messageElements = OGPlugin_FilterSpyReportsText(messageElements); // à revoir !!!

            //if (ogs_getreportsdebug_mode) alert(messageElements);

            if (messageElements.length>10)
                OGPlugin_result = OGPlugin_sendText(SendButtonActionCmd,messageElements,OGPlugin_TrigDoc.location.href);
        } else alert('Aucun rapport captur\u00e9!');

}

/**
 *
 **/
function OGPlugin_SendToGate_OnClick() {

  if (SendButtonActionCmd =='galaxy')
      var datatext = OGPlugin_GetGalaxyTextSel(OGPlugin_TrigDoc);
  else if (SendButtonActionCmd =='reports') {
      var datatext = OGPlugin_GetMessagesText(OGPlugin_TrigDoc);
      
      // filtrage des points de nombre
      if (OGPlugin_getBoolPref('OGPlugin.settings.filterpointsnumber', true, '')==true)
      datatext = OGPlugin_FilterNumberPoints(datatext);
  }

  // 'ogspymodsend', 'ogspygatesend'
  OGPlugin_result = OGPlugin_sendText(SendButtonActionCmd,datatext,CurrentDocUrl, 'ogspygatesend');
}





