/*
Barre d'Outils OGSPY, extension firefox d'aide aux mise  jour de serveurs OGSPY

OGSPY Toolbar, a firefox plugin for helping players in updating OGSPY servers game datas

Copyright (C) 2006-2007 Naqdazar (ajdr@free.fr)

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier
au titre des clauses de la Licence Publique Gnrale GNU, telle que publie par la
Free Software Foundation ; soit la version 2 de la Licence.
Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ;
 sans mme une garantie implicite de COMMERCIABILITE ou DE CONFORMITE A UNE UTILISATION PARTICULIERE. 
 
 Voir la Licence Publique Gnrale GNU pour plus de dtails. 
 
 Vous devriez avoir reu un exemplaire de la Licence Publique Gnrale GNU avec ce programme ;
  si ce n'est pas le cas, crivez  la Free Software Foundation Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

This program is free software; you can redistribute it and/or modify it under the
terms of the GNU General Public licence as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 See the GNU General Public License for more details.

You should have received a copy of the GNU General Public licence along with this program;
 if not, write to the Free Software Foundation, Inc., 
 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

const ogsgetdata_debug=false;
const ogs_ogamegalinput = 3; // indice de la boite ogame du no de galaxie
const ogs_eunivgalinput = 1; // indice de la boite eunivers du no de galaxie
const ogs_ogamesysinput = 6; // indice de la boite ogame du no de systme
const ogs_eunivsysinput = 4; // indice de la boite eunivers du no de systme

/* code et fonctions de projets libres tiers */
/* Surcharge class String */

/** @class String
 *  @brief classe de base du type chane implmente par la navigateur.
 *
 *  Classe surcharge.
 *  mthode trim()
 */

 /** 
 *  \fn trim
 *   fonction qui retire les espace blancs en dbut et fin de chane
 *  @return retourne la chane reue en entre dgage de ses espaces de dbut et de fin
 */
String.prototype.trim = function() {
  var x=this;
  x=x.replace(/^\s*|\s*$/g,'');
  return x;
}
//-----------------------------------------------------------------------------------------
/* String.prototype.stripSlashes = function() {
  var x=this;
  x=x.replace(/[\\,']/gi, '\'); // /<\/?[^>]+>/gi ou '<\/?[^>]+>','gi'
  return x;
} */
//-----------------------------------------------------------------------------------------
/*! stripHTMLEntities  */
String.prototype.stripHTMLEntities = function(removehtmljavascripted) {
  var x=this;
  if (removehtmljavascripted==true) x=x.replace(/escape\(['"].*['"]\);?/gi, "\'\'");
  x=x.replace(/<\/?[^>]+>/gi, ''); // /<\/?[^>]+>/gi ou '<\/?[^>]+>','gi'
  return x;
}
//-----------------------------------------------------------------------------------------
String.prototype.retrim = function() {
  var x=this.trim();
  x=x.replace(/\s+/g,' ');
  return x;
}

/**
 * galit de chaine sans distinction casse
 **/
String.prototype.IsNSCEqual = function(stringtocomp) { // galit de chaine sans distinction casse
      var x=this.trim();
      if (x.length!=stringtocomp.length) return false;
      var stringtosearch = stringtocomp.replace(/([ \., \^, \$, \+, \-, \?, \*, \[, \], \(, \)])/gi,"\\$1"); // -> sinon .I. reconnait BIO     
      if (x.search(stringtosearch, "i")==0) return true;
      else return false;	  
}

/**
 * tranforme une chane pour tre utilise dans une expression rgulire
 **/
String.prototype.StringToRegExp = function() { // 
      var x=this.trim();
      if (x.length==0) return false;
      var stringtoescape = "";
      stringtoescape = x.replace(/([ \., \^, \$, \+, \-, \?, \*, \[, \], \(, \)])/gi,"\\$1"); // -> sinon .I. reconnait BIO
      return stringtoescape;
}



 /*! \fn String.prototype.IsNSCEqual
 *  String.prototype.IsNSCEqual 
 */
function OGPlugin_getGalaxy(docroot) {
    // rcupre l'info sur la galaxie en cours
    // dfinit l'indice suivante le type de jeu
    if (ogs_gametype==ogs_ogametype) var tmpgalinput = ogs_ogamegalinput;
    else if(ogs_gametype==ogs_euniverstype) var tmpgalinput = ogs_eunivgalinput;
    try {
        if (parseInt(docroot.getElementsByTagName("input")[tmpgalinput].value) > 0) {
            return docroot.getElementsByTagName("input")[tmpgalinput].value;
        } else {
            return docroot.getElementsByTagName("input")[tmpgalinput+1].value;
        }
    } catch (e){
        OGPlugin_SetStatusViewLabel("notify", "Erreur en capturant la galaxie"/* OGPlugin_GetLocString("error.gvnotupdated") */);
        return -1;
    }
}

function OGPlugin_getSystem(docroot) {
    // rcupre l'info sur le systme en cours
    if (ogs_gametype==ogs_ogametype) var tmpsysinput = ogs_ogamesysinput;
    else if(ogs_gametype==ogs_euniverstype) var tmpsysinput = ogs_eunivsysinput;
    try {
        if (parseInt(docroot.getElementsByTagName("input")[tmpsysinput].value) > 0) {
            return docroot.getElementsByTagName("input")[tmpsysinput].value;
        } else {
            return docroot.getElementsByTagName("input")[tmpsysinput+1].value;
        }
    } catch (e){
        OGPlugin_SetStatusViewLabel("notify", "Erreur en capturant le systeme" /* OGPlugin_GetLocString("error.gvnotupdated")*/);
        return -1;
    }

}

function OGPlugin_getStatsWho(docroot) {
    // rcupre l'info sur la catgorie slectionne - joueur=0 , alliance=1
    var optionElements = docroot.getElementsByTagName("select")[1].getElementsByTagName("option");
    //var optionElements = docroot.getElementsByName("who").getElementsByTagName("option");
    for (var j = 0; j < optionElements.length; j++) {
        var optionElement = optionElements.item(j);
        if (optionElement.hasAttribute("selected")) {
            return j;
        }
    }
    return -1;
}


function OGPlugin_getStatsTyp(docroot) {
    // rcupre l'info sur ce qui est slectionn - points=0 ou flotte=1 or recherche=2
    var optionElements = docroot.getElementsByTagName("select")[2].getElementsByTagName("option");
    //var optionElements = docroot.getElementsByName("type").getElementsByTagName("option");
    for (var j = 0; j < optionElements.length; j++) {
        var optionElement = optionElements.item(j);
        if (optionElement.hasAttribute("selected")) {
            return j;
        }
    }
    return -1;
}

function OGPlugin_getStatswhitch(docroot) {
    // rcupre l'info sur l'intervalle de rang slectionn
    var optionElements = docroot.getElementsByTagName("select")[3].getElementsByTagName("option");
    //var optionElements = docroot.getElementsByName("start").getElementsByTagName("option");
    for (var j = 0; j < optionElements.length; j++) {
        var optionElement = optionElements.item(j);
        if (optionElement.hasAttribute("selected")) {
            return optionElement.innerHTML;
            //return j;
        }
    }
    return -1;
}

// alert(OGPlugin_getStatsText(OGPlugin_TrigDoc, false));
function OGPlugin_getStatsText(docroot, foxgamestatbutton) {
    
    var rows ; 
    if (docroot==null) alert("OGPlugin_getStatsText: Erreur docroot non dfini!");
    
    if (ogs_gametype==ogs_ogametype)
        targettablerank = OGPlugin_getIntPref('OGPlugin.settings.statspagetablerank', ogs_StatsPageRankTab, '');
    else if(ogs_gametype==ogs_euniverstype) targettablerank = OGPlugin_getIntPref('OGPlugin.settings.eunivstatspagetablerank', eun_StatsPageRankTab, '')/* 6 */;
    
    if (foxgamestatbutton==true) rows = docroot.getElementsByTagName('table')[targettablerank+1].rows; // Ogame 0.76 [6] -> [7]
    else rows = docroot.getElementsByTagName('table')[targettablerank].rows; // Ogame 0.76 [5] -> [6]

    tab_length = rows.length-1;
    if (tab_length<1) return "statsnodata"; // pas de classement disponible ou donnes vide
    //else if (rows.length<101) return "partialstatsdata";

    //alert(foxgamestatbutton+"-"+rows[1].cells[1].innerHTML)
    var cells;
    var sep_points = new RegExp(/[\.,\,,\s]|&nbsp;/g);

    if(OGPlugin_selectedWho == 0) { //Players
        var ranks = new Array(tab_length);
        var players = new Array(tab_length);
        var pIds = new Array(tab_length);
        var alliances = new Array(tab_length);
        var points = new Array(tab_length);
        var j, points_capt;
        var pIdRegExp = /messageziel\=(\d+)/;
        
        
        for(var i = rows.length - 2; i >= 0; i--) {
            j = 0;
            cells      = rows[i+1].cells;
            ranks[i]   = parseInt(cells[j++].innerHTML);
            players[i] = cells[j++];

            try {
                while(players[i].firstChild) {
                    players[i] = players[i].firstChild;
                }
            } catch(e) {
                alert("exception, player.... :"+i);
            }

            players[i] = players[i].nodeValue;
            try {                
                pIds[i] = cells[j++].innerHTML.match(pIdRegExp)[1];
            } catch(e) { }
            // filtrer ici pour retirer TAG alliance du lien html
            //var ogame_linkally = new RegExp(/<a\shref=\\"ainfo.php\?allytag=.+\\"\s?target=\\"_ally\\">\t*\s*\n?\s+(.+)<\/a>/i);
            
            alliances[i] = OGPlugin_HTMLTagstoText(cells[j++].innerHTML);
            //if (ogsgetdata_debug==true) alert("Stats: Alliance->"+OGPlugin_HTMLTagstoText(alliances[i])+"/"+alliances[i]);
            
            points_capt = cells[j].innerHTML.stripHTMLEntities(true);
            
            if (OGPlugin_getBoolPref('OGPlugin.settings.filterpointsnumber', true, '')==true) {
                nb_points = points_capt.replace(sep_points,"");
                //nb_points = nb_points.replace(sep_points,"");
                points[i]    = parseInt(nb_points);
            } else points[i] = points_capt;
            // debug if (i<5) alert("point remplac : "+nb_points);
        }

        var data = "";
        data += "&ranks=" + ranks.join("|");
        data += "&players=" + players.join("|");
        data += "&pIds=" + pIds.join("|");
        data += "&alliances=" + alliances.join("|");
        data += "&points=" + points.join("|");
        //alert(points.join("|"));
                
        
    } else { // Alliances
        var ranks = new Array(tab_length);
        var alliances = new Array(tab_length);
        var members = new Array(tab_length);
        var points = new Array(tab_length);
        var j;
        for(var i = rows.length - 2; i >= 0; i--) {
            j = 0;
            cells = rows[i+1].cells;
            ranks[i] = parseInt(cells[j++].innerHTML);
            if (ogs_gametype==ogs_euniverstype) j++; // 3e colonne EUnivers 2.12
            
            alliances[i] = cells[j++];
            //if (i==10) alert(alliances[i].innerHTML.stripHTMLEntities(true).replace(/[\[\]]/g, ''));

            if (ogs_gametype==ogs_ogametype) {
                while(alliances[i].firstChild)
                    alliances[i] = alliances[i].firstChild;
                if(alliances[i].nodeValue!=null) {
                    alliances[i] = alliances[i].nodeValue.stripHTMLEntities(true);
                } else {
                  alliances[i] = cells[j-1].innerHTML.stripHTMLEntities(true);
                }
            } else  alliances[i] = alliances[i].innerHTML.stripHTMLEntities(true).replace(/[\[\]]/g, '');

            if (ogs_gametype==ogs_ogametype) {
                j++;
                members[i] = cells[j++].innerHTML;
            } else members[i] = '0';
            
            if (OGPlugin_getBoolPref('OGPlugin.settings.filterpointsnumber', true, '')==true) {
                nb_points = cells[j++].innerHTML.replace(sep_points,"");
                points[i]    = parseInt(nb_points);
            } else points[i] = cells[j++].innerHTML;
				
           //by Jormund 
			  alliances[i]=alliances[i].replace(/\|/g,"");
			  members[i]=members[i].replace(/\|/g,"");
        }

        var data = "";
        data += "&ranks=" + ranks.join("|");
        data += "&alliances=" + alliances.join("|");
        data += "&members=" + members.join("|"); // garder tous les champs pour compat avec le module OGS Plugin standard
        data += "&points=" + points.join("|");
        //alert(points.join("|"));
    }
    //alert(data);
    return data;
}

// alert(OGPlugin_get_galaxyview_data(OGPlugin_TrigDoc, true));
function OGPlugin_get_galaxyview_data(docroot,foxgame) {

    // Indice table correspondante EUnivers = 8
    if (ogs_gametype==ogs_ogametype)
        targettablerank = OGPlugin_getIntPref('OGPlugin.settings.galpagetablerank', ogs_GalaxyPageRankTab, '');
    else if(ogs_gametype==ogs_euniverstype) targettablerank = OGPlugin_getIntPref('OGPlugin.settings.eunivgalaxytablerank', eun_GalaxyPageRankTab, '') /* 8 */;
//alert(docroot.getElementsByTagName('table')[targettablerank].innerHTML);//by jormund
    var rows = docroot.getElementsByTagName('table')[targettablerank].rows;
    var enablegalviewbuffering=false; // par dfaut
    var cells;
    var galaxyview = new Array(15);
    var galaxy_content;
    var posRegExp = />(\d+)<\/a>/;


    var moonsize;
    var metal_debris;
    var crystal_debris;
    var planetname;
    var corrector = 0;
    if (ogs_gametype==ogs_euniverstype) foxgame=true;
    // cas foxgame seulement valable sous Ogame
    if (ogs_gametype==ogs_ogametype && foxgame == true) {
        corrector = 1; // foxgame dplace la plante, retirer 1 de la coordonne cellule du tableau
    }

    // rcupre la chane "systme solaire" pour dterminer la langue ultrieurement
    cells = rows[0].cells;
    var solar_system = cells[0].innerHTML;
    solar_system = solar_system.replace(/\s/,"");
    for(var i = 2; i < 17; i++) {
        // reset data
        moonsize = 0;
        metal_debris = 0;
        crystal_debris = 0;
        playerid = 0;
        playerstatus = "";
        playername = "";
        planetname = "";
        alliance = "";

        cells = rows[i].cells;
        /**
         *  moonsizecell = cells[3-corrector];
         *  moonsizecellimg = moonsizecell.getElementsByTagName('img')[0];
         *  remplacement des blocs try  revoir
         **/
        try {
            if (ogs_gametype==ogs_ogametype) moonsize = parseInt(cells[3-corrector].getElementsByTagName('img')[0].getAttribute('alt').match(/(\d+)/)[1]);
            else { /*pas encore de lune!! */ }
        } catch(e) { /* pas de lune */ }


        // filtrage des champs de ruines
        if (OGPlugin_getBoolPref('OGPlugin.settings.filterdebrisfield', false, '')==false) {
            try {
                if (ogs_gametype==ogs_ogametype) var tmp = cells[4-corrector].innerHTML.match(RegExpOgamedebris);
                else var tmp = cells[0].getElementsByTagName('a')[0].getAttribute('title').match(RegExpEuniversdebris);
                if (tmp != null) {
                    metal_debris = parseInt(tmp[1].replace(/\./g,'')) ; //replace(".","").replace(".","").replace(".",""));
                    crystal_debris = parseInt(tmp[2].replace(/\./g,'')) ; //.replace(".","").replace(".","").replace(".",""));
                }
            } catch(e) { /* pas de champ de ruine */ }
         
        } else { // les valeurs suivantes indiqueront au module de ne pas insrer les donnes
          metal_debris = -1;
          crystal_debris = -1;
        }

        if (ogs_gametype==ogs_ogametype) {
            if (foxgame == true) {
                try { // une plante existe-t-elle?
                    planetname = cells[2-corrector].getElementsByTagName('a')[0].getElementsByTagName('a')[0].innerHTML;
                }catch(e) { // aucune plante n'existe
                    try { planetname = cells[2-corrector].getElementsByTagName('a')[0].innerHTML; /*     */
                    }catch(e) { /* aucune plante n'existe */ }
                }
            } else {
                try { planetname = cells[2].getElementsByTagName('a')[0].innerHTML.stripHTMLEntities(true).trim(); /* une plante existe */
                } catch(e) { planetname = cells[2].innerHTML.stripHTMLEntities().trim(); /* aucune plante n'existe */ }
            }
        } else {
            try { planetname = cells[1].getElementsByTagName('a')[0].innerHTML.stripHTMLEntities().trim(); /* une plante existe */
            } catch(e) { planetname = cells[1].innerHTML.stripHTMLEntities(true).trim(); /* aucune plante n'existe */ }
        }
        //alert("planetname: "+planetname);

        planetname = planetname.replace(/\([0-9a-zA-Z\*\+\s]+\)/,""); // remove activity behind planet name
        planetname = planetname.replace("&nbsp;","");
        planetname = planetname.replace(/\s/,"");
			planetname = planetname.replace(/\|/g,"");//by Jormund
			
        galaxy_content = parseInt(cells[0].innerHTML.match(posRegExp)[1])+"|"; // position
        galaxy_content += planetname+"|"; // nom de plante
        /* if (ogs_gametype==ogs_ogametype) */ galaxy_content += moonsize+"|"; // lune
        galaxy_content += metal_debris+"|"; // champ de dbris(mtal)
        galaxy_content += crystal_debris+"|"; // champ de dbris(cristal)
        //-----------------------------------------------------------------------------------
        /* var playercell = cells[5-corrector];
        var playercellspans = cells[5-corrector].getElementsByTagName('span'); */

        if (ogs_gametype==ogs_ogametype) { // cas Ogame
            /* if (playercellspans[0]!=null) { // la cellule cible existe-t-elle?
                playername = playercellspans[0].innerHTML.stripHTMLEntities().trim(); 			 // nom joueur
                for (var j=1; j<7; j++) {
                    playerstatus += playercellspans[j].innerHTML;
                }
            } */
            // code original try...except
            try {
                playername = cells[5-corrector].getElementsByTagName('span')[0].innerHTML.stripHTMLEntities().trim(); 			 // nom joueur
                //alert("getgal playername: "+playername);
                // rcupre le drapeau du joueur - au max 6 lments (i,I,u,g,s,n)
					// alert(playername);
					//ufLog('FIRESPY:'+playername);
                for (var j=1; j<7; j++) {
                    playerstatus += cells[5-corrector].getElementsByTagName('span')[j].innerHTML;
                }

            } catch(e) { /* alert("no player name found \n"+e); */ /* catch when there is no player or last playerstatus was found */ }
            
        } else { //  revoir
            //playername = playercell.getElementsByTagName('a')[0].innerHTML.stripHTMLEntities().trim(); // cas eunivers

            try {
					span=cells[3].getElementsByTagName('span')[0];
					//ufLog(span.firstChild);
					if(span.firstChild.toString()=='[object XPCNativeWrapper [object HTMLFontElement]]')span=span.firstChild;
					/*fonts=span.getElementsByTagName('font');
					playername_tmp='';
					if(typeof fonts !='undefined')//cas particulier du joueur courrant
						if(fonts)
							if(fonts.length)
								playername_tmp=fonts[0].innerHTML;
					if(playername.length==0)	//cas gnral */
						playername_tmp = span.innerHTML;
					 //ufLog("firespy: "+playername_tmp);
                //playername_tab = playername_tmp.match(/([\w,\s,\.,_,\-,@]*\S)($|\s\((\+\d+)\))/);
                playername_tab = playername_tmp.match(/([^\(]*)($|\s\((\+\d+)\))/);
					 //Xdump(playername_tab);
                if (playername_tab != null) {
                    playername = playername_tab[1];
                    if (playername_tab[3]!=null) playerstatus = playername_tab[3]
                    else playerstatus="";
                }
					 //playerstatus = "";
                //alert("getgal playername: "+playername);
                // rcupre le drapeau du joueur - au max 6 lments (i,I,u,g,s,n)
                /*for (var j=1; j<7; j++) {
                    //playerstatus += cells[3].getElementsByTagName('span')[j].innerHTML;
                } */

            } catch(e) { /* alert("no player name found \n"+e); */ /* catch when there is no player or last playerstatus was found */ }
        }
        //ufLog(playername+"-"+playerstatus);
		  playername=playername.replace(/\|/g,"");//by Jormund
			
        //-----------------------------------------------------------------------------------
        galaxy_content += playername+"|";
        galaxy_content += playerstatus+"|"; // add playerstats
        //-----------------------------------------------------------------------------------
        /* var alliancecell = cells[6-corrector];
        var alliancecelllink = cells[6-corrector].getElementsByTagName('a')[0];
        if (alliancecelllink!=null) {
            if (alliancecelllink.getElementsByTagName('span')[0]!=null) // propre alliance
                alliance = alliancecelllink.getElementsByTagName('span')[0].innerHTML.stripHTMLEntities().trim();
            else alliance = alliancecelllink.innerHTML.stripHTMLEntities().trim(); // autre alliance
            alliance = alliance.replace(/\n+/,"");
        } */

        try { // blocs try except  remplacer
            try {
                // propre alliance
                if (ogs_gametype==ogs_ogametype) alliance = cells[6-corrector].getElementsByTagName('a')[0].getElementsByTagName('span')[0].innerHTML.stripHTMLEntities().trim(); // alliance
                else alliance = cells[4].getElementsByTagName('a')[0].getElementsByTagName('span')[0].innerHTML.stripHTMLEntities(true).trim(); // alliance
            } catch(e) {
                // autre alliance
                if (ogs_gametype==ogs_ogametype) alliance = cells[6-corrector].getElementsByTagName('a')[0].innerHTML.stripHTMLEntities().trim(); // alliance
                else alliance = cells[4].getElementsByTagName('a')[0].innerHTML.stripHTMLEntities(true).trim(); // alliance
            }
        } catch(e) { /* alert("no ally found \n"+e); */ /* catch when there is no alliance */ }

        alliance = alliance.replace(/\n+/,"");
		  alliance = alliance.replace(/\|/g,"");//by Jormund
        //-----------------------------------------------------------------------------------
        galaxy_content += alliance+"|";

        // tentative de rcuprer l'id joueur
        try {
            if (ogs_gametype==ogs_ogametype) playerid = parseInt(cells[7-corrector].getElementsByTagName('a')[1].getAttribute('href').match(/messageziel=(\d+)/)[1]);
            else playerid = parseInt(cells[5].getElementsByTagName('a')[1].getAttribute('href').match(/dest=(\d+)/i)[1]);
        } catch(e) { /* pas d'id jouer trouve (aucune plante ou plante du joueur */ }
        galaxy_content += playerid;


        // efface tous les \n de cette chane
        galaxy_content = galaxy_content.replace(/\n+/,"");
        galaxyview[i] = galaxy_content;
    }


    // mise en tampon
    enablegalviewbuffering = OGPlugin_getBoolPref('OGPlugin.settings.enablegalviewbuffering',false,'');
    if (enablegalviewbuffering==true && ogs_gametype==ogs_ogametype) {
        if (Curr_GalViewBufCount==0) var galaxystring = solar_system + galaxyview.join("\n");
        else var galaxystring = "<==||==>" + solar_system + galaxyview.join("\n");
    } else var galaxystring = solar_system + galaxyview.join("\n"); // pas de tampon
	//Xdump(galaxystring);
		//galaxystring=galaxystring.replace(/\|/g,"");
  //  if (ogs_galaxycontentdebug_mode==true) 
	// alert(galaxystring);
    return galaxystring;
}
